/*
 * File generated by SourceCombiner.exe using 18 source files.
 * Created On: 4/22/2022 8:40:17 AM
*/
using MVR.FileManagementSecure;
using SimpleJSON;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Text.RegularExpressions;
using uFileBrowser;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
//*** SourceCombiner -> original file VAM_Decal_Maker.cs ***
namespace VAM_Decal_Maker
{
    public class Decal_Maker : MVRScript
    {
        private const string pluginName = "DecalMaker";
        private const string pluginVersion = "Beta 9";
        //person script is attatched too
        private Atom _parentAtom; //VAM parent
        private Atom _shaderAtom; //Obj holding shader
        private bool _SetupFinished = false;
        private bool _ShadersLoaded = false;
        private int _queuedBakes = 0;
        public Shader _customBulkDecalShader { get; private set; }
        public Shader _customSpecGlossShader { get; private set; }
        public Shader _customNormShader { get; private set; }
        public Shader _customPackedNormShader { get; private set; }
        public Shader _customUINormalMapShader { get; private set; }
        public Shader _customUISpecularMapShader { get; private set; }
        public Shader _customUIGenitalMakerShader { get; private set; }
        public JSONClass _savedData { get; set; }
        public static Dictionary<string, Texture2D> resourceTextures = new Dictionary<string, Texture2D>();
        public Texture2D GetResource(string path, bool linear = false)
        {
            Texture2D texture;
            if (resourceTextures.TryGetValue(path, out texture))
            {
                return texture;
            }
            //not in dictionary
            byte[] tmppng = FileManagerSecure.ReadAllBytes(GetPackagePath(this) + path);
            texture = new Texture2D(1, 1, TextureFormat.RGBA32, linear);
            texture.LoadImage(tmppng);
            resourceTextures.Add(path, texture);
            return texture;
        }
        public Texture2D _clearTex { get { return GetResource("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Clear.png"); } }
        public DAZMergedSkinV2 _dazSkin { get; private set; }
        //Events
        public Action OnUpDate;
        public Dictionary<string, int[]> _TextureIndex
        {
            get
            {
                if (_isMale)
                    return maleTextureIndex;
                return femaleTextureIndex;
            }
        }
        private Dictionary<string, int[]> femaleTextureIndex = new Dictionary<string, int[]>()
        {
            {"torso", new int[]{15,18,19,20,21,27,29}},
            {"face", new int[]{2,5,11} },
            {"limbs", new int[]{0,12,14,16,17,22,23}},
            {"genitals", new int[]{28}}
        };
        private Dictionary<string, int[]> maleTextureIndex = new Dictionary<string, int[]>()
        {
            {"torso", new int[]{15,16,19,20,21,22,30,32}},
            {"face", new int[]{2,5,11}},
            {"limbs", new int[]{0,12,14,17,18,23,24}},
            {"genitals", new int[]{28,29}}
        };
        private DAZCharacter _dazCharacter;
        private DAZCharacterSelector _dazCharacterSelector;
        public bool _isMale;
        public string _uvSetName;
        //UI
        public JSONStorableBool _toggleNippleCutout;
        public JSONStorableBool _toggleGenitalCutout;
        private UIDynamicButton _resetButton;
        private UIDynamicButton _saveButton;
        private UIDynamicButton _clearAllButton;
        private UIDynamicButton _prefabButton;
        private UIDynamicButton _savePresetButton;
        private UIDynamicButton _loadPresetButton;
        private UIDynamicToggle _toggleNipple;
        private UIDynamicToggle _toggleGenital;
        public HeaderPanel _headerPanel;
        //GenitalMaker _genitalMakerPanel;
        public PreviewAnchor _previewAnchor { get; private set; }
        private bool _Debug = false;
        public void ToggleGensCallBack(bool value)
        {
            OnCoreChange(this, new PanelEventArgs("_toggleGenitalCutout", value));
        }
        public void ToggleNipsCallBack(bool value)
        {
            OnCoreChange(this, new PanelEventArgs("_toggleNippleCutout", value));
        }
        //System.Diagnostics.Stopwatch watch = System.Diagnostics.Stopwatch.StartNew();
        public override void Init()
        {
            try
            {
                if (containingAtom.mainController == null)
                {
                    SuperController.LogError("Please add this plugin to a PERSON atom.");
                    return;
                }
                _parentAtom = containingAtom;
                _parentAtom.mainController.interactableInPlayMode = true;
                //setup all values before finishing UI
                StartCoroutine(CharacterChanged());
                StartCoroutine(CreateAssetAtom("Chokpahi-Asset", "Chokpahi-Asset"));
                _clearAllButton = CreateButton("Clear Everything");
                _prefabButton = CreateButton("USE Prefab", true);
                PrefabPanel prefabPanel = new PrefabPanel(this);
                //_genitalMakerPanel = new GenitalMaker(this);
                _resetButton = CreateButton("Reset Texture");
                _saveButton = CreateButton("This Space 4 Rent", true);
                _loadPresetButton = CreateButton("Load Preset");
                _savePresetButton = CreateButton("Save Preset", true);
                _toggleNippleCutout = new JSONStorableBool("Nipple Cutouts ON", true, new JSONStorableBool.SetBoolCallback(ToggleNipsCallBack));
                _toggleNipple = CreateToggle(_toggleNippleCutout);
                _toggleGenitalCutout = new JSONStorableBool("Genital Cutouts ON", true, new JSONStorableBool.SetBoolCallback(ToggleGensCallBack));
                _toggleGenital = CreateToggle(_toggleGenitalCutout, true);
                RegisterBool(_toggleNippleCutout);
                RegisterBool(_toggleGenitalCutout);
                GetBoolJSONParam("Nipple Cutouts ON");
                //assign listners
                _clearAllButton.button.onClick.AddListener(ResetAll);
                _prefabButton.button.onClick.AddListener(prefabPanel.OnClick);
                string presetsPath = "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets";
                if (!FileManagerSecure.DirectoryExists(presetsPath))
                {
                    FileManagerSecure.CreateDirectory(presetsPath);
                }
                if (!FileManagerSecure.DirectoryExists(presetsPath + "/PreFabs"))
                {
                    FileManagerSecure.CreateDirectory(presetsPath + "/PreFabs");
                }
                _savePresetButton.button.onClick.AddListener(() =>
                {
                    SuperController.singleton.fileBrowserUI.defaultPath = presetsPath;
                    SuperController.singleton.fileBrowserUI.showFiles = true;
                    SuperController.singleton.fileBrowserUI.showDirs = true;
                    SuperController.singleton.fileBrowserUI.SetTextEntry(true);
                    SuperController.singleton.fileBrowserUI.hideExtension = true;
                    SuperController.singleton.fileBrowserUI.shortCuts = new List<ShortCut>();
                    SuperController.singleton.fileBrowserUI.Show(SavePresetCallback);
                });
                _loadPresetButton.button.onClick.AddListener(() =>
                {
                    string presets = "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets";
                    SuperController.singleton.fileBrowserUI.defaultPath = presets;
                    SuperController.singleton.fileBrowserUI.SetTitle("Select Load Decal Preset");
                    SuperController.singleton.fileBrowserUI.showFiles = true;
                    SuperController.singleton.fileBrowserUI.showDirs = true;
                    SuperController.singleton.fileBrowserUI.SetTextEntry(false);
                    SuperController.singleton.fileBrowserUI.hideExtension = true;
                    List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets", false, true, true, false);
                    SuperController.singleton.fileBrowserUI.shortCuts = shortCuts;
                    SuperController.singleton.fileBrowserUI.Show(PresetLoadCallBack);
                });
                JSONStorableAction resetAllAction = new JSONStorableAction("ClearAll", ResetAll);
                RegisterAction(resetAllAction);
                JSONStorableAction performLoadAction = new JSONStorableAction("PerformLoad", PerformLoad);
                RegisterAction(performLoadAction);
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Error during Init" + e);
            }
        }
        private void LogError(string err)
        {
            if (_Debug)
            {
                SuperController.LogError(err);
            }
        }
        public void DebugSave(Texture2D tempTex, string name)
        {
            string path = "Custom/PluginData/Chokaphi/VAM_Decal_Maker/" + name;
            byte[] bytes = tempTex.EncodeToPNG();
            FileManagerSecure.WriteAllBytes(path, bytes);
        }
        //MacGruber Discord 03/26/2020
        //Get directory path where the plugin is located. Based on Alazi's & VAMDeluxe's method.
        public static string GetPluginPath(MVRScript self)
        {
            string id = self.name.Substring(0, self.name.IndexOf('_'));
            string filename = self.manager.GetJSON()["plugins"][id].Value;
            return filename.Substring(0, filename.LastIndexOfAny(new char[] { '/', '\\' }));
        }
        // Get path prefix of the package that contains our plugin.
        public string GetPackagePath()
        {
            return GetPackagePath(this);
        }
        public static string GetPackagePath(MVRScript self)
        {
            string filename = GetPluginPath(self);
            int idx = filename.IndexOf(":/");
            if (idx >= 0)
                return filename.Substring(0, idx + 2);
            else
                return string.Empty;
        }
        //By: VAMDeluxe Discord
        public List<string> GetFilesAtPathRecursive(string path, string pattern)
        {
            List<string> combined = new List<string>();
            string[] files = FileManagerSecure.GetFiles(path, pattern);
            string[] directories = FileManagerSecure.GetDirectories(path);
            List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory(path);
            files.ToList().ForEach(file =>
            {
                combined.Add(file);
            });
            directories.ToList().ForEach(directory =>
            {
                combined.AddRange(GetFilesAtPathRecursive(directory, pattern));
            });
            return combined;
        }
        //from C# PATH
        private char[] sep = new char[] { '/', '\\' };
        public string GetFileName(string path)
        {
            int num = path.LastIndexOfAny(sep);
            if (num >= 0)
            {
                return path.Substring(num + 1);
            }
            return path;
        }
        //"project-canyon12/05/2018 DISCORD"
        //"I'm going on how I understand Async/Await works in normal C#, but I think the principle is the same"
        //tweaked for my use case
        private delegate void AtomCreatedEvent(Atom atom);
        private IEnumerator CreateAssetAtom(string uniqueAtomName, string nameOfGameObjectToFind)
        {
            //yield return new WaitForSeconds(0.5f);
            Atom createdAtom = GetAtomById(uniqueAtomName);
            if (createdAtom == null)
            {
                yield return SuperController.singleton.AddAtomByType("CustomUnityAsset", uniqueAtomName, true);
                createdAtom = GetAtomById(uniqueAtomName);
            }
            JSONStorable storable = createdAtom.GetStorableByID("asset");
            //should have always had this toggled. Prevents asset from being stored
            storable.exclude = true;
            storable.SetUrlParamValue("assetUrl", GetPackagePath(this) + @"Custom\Assets\Chokaphi\chokpahi-decal.assetbundle");
            storable.SetStringChooserParamValue("assetName", "Assets/Chokpahi-Decal.unity");
            yield return new WaitWhile(() => GameObject.Find(nameOfGameObjectToFind) == null);
            LogError("Asset loaded");
            _shaderAtom = createdAtom;
            LogError("Asset Shader loaded " + createdAtom);
        }
        private void DefineShaders()
        {
            Shader[] renderers = Resources.FindObjectsOfTypeAll<Shader>();
            LogError("Shader setup start. Shaders loaded= " + renderers.Length);
            foreach (Shader shader in renderers)
            {
                if (shader.name == "Custom/Unlit-Specular2")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " Spec-Gloss Shader is " + shader.name);
                    _customSpecGlossShader = shader;
                }
                if (shader.name == "Custom/Unlit-NormalMap2")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " Normal Shader is " + shader.name);
                    _customNormShader = shader;
                }
                if (shader.name == "Custom/Unlit-PackedNormalMap")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " PackedNorm Shader is " + shader.name);
                    _customPackedNormShader = shader;
                }
                if (shader.name == "Custom/Unlit-Decal4")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " BulkShader Shader is " + shader.name);
                    _customBulkDecalShader = shader;
                }
                if (shader.name == "Custom/UI-NormalMapOverlay")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " ui Shader is " + shader.name);
                    _customUINormalMapShader = shader;
                }
                if (shader.name == "Custom/Unlit-GenitalMaker2")
                {
                    LogError("ShaderFind " + Shader.Find(shader.name) + " ui Shader is " + shader.name);
                    _customUIGenitalMakerShader = shader;
                }
            }
            if (_customSpecGlossShader && _customNormShader && _customPackedNormShader && _customBulkDecalShader && _customUINormalMapShader && _customUIGenitalMakerShader)
            {
                _ShadersLoaded = true;
            }
        }
        // Update is called with each rendered frame by Unity
        private void Update()
        {
            try
            {
                //Fire UpdateEvents to subscribers
                if (_SetupFinished == true && OnUpDate != null)
                {
                    OnUpDate();
                }
                if (_dazCharacter != null)
                {
                    if (_dazCharacter != _dazCharacterSelector.selectedCharacter)
                    {
                        StartCoroutine(CharacterChanged());
                    }
                }
                if (_ShadersLoaded == false)
                {
                    LogError("On update call waiting on _customBulkDecalShader");
                    DefineShaders();
                }
                if (_SetupFinished == false && _ShadersLoaded == true)
                {
                    LogError("On update call waiting on SetUp");
                    Setup();
                    LogError("setup should be finished " + _SetupFinished);
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
        //A public event for listeners to subscribe to
        public event EventHandler<PanelEventArgs> CoreEvent;
        public void OnCoreChange(object o, PanelEventArgs e)
        {
            //Fire the event - notifying all subscribers
            if (CoreEvent != null)
                CoreEvent(o, e);
        }       
        //called on reload or removal of plugin
        public void OnDestroy()
        {
            ResetOriginalGPUTextures(_dazCharacter);
        }
        public void Setup()
        {
            try
            {
                _previewAnchor = new PreviewAnchor(this);
                //create Header Panel
                _headerPanel = new HeaderPanel(this);
                _resetButton.button.onClick.AddListener(() =>
                {
                    ResetOriginalGPUTextures(_dazCharacter);
                });
                //UIDynamicButton NewPanelButton = CreateButton(" LAST LEFT ELEMENT");
                //NewPanelButton.button.onClick.AddListener(() =>
                //{
                //   var a = _headerPanel.SelectionPanelNorm.Selections["face"].mainTexture;
                //    SuperController.LogError("Text is " + a);
                //    //RenderPanelDecal rp =  _headerPanel.SelectionPanelDecal.FacelPanel.renderPanel;
                //    //SuperController.LogError("Render panel clicked " + rp.TextureSlot + " " + rp.MaterialSlot + rp.material);
                //    //if (rp.material == null)
                //    //{
                //    //    rp.material = new Material(_customBulkDecalShader);
                //    //}
                //    //rp.IsDirty = true;
                //});
                //UIDynamicButton UnusedButton2 = CreateButton("LAST RIGHT ELEMENT", true);
                //UnusedButton2.button.onClick.AddListener(() =>
                //{
                //    _parentAtom.tempDisableRender = !_parentAtom.tempDisableRender;
                //    SuperController.singleton.SyncHiddenAtoms();
                //});
                //this is hacky but sets the UI to look nice on start.
                _prefabButton.button.onClick.Invoke();
                _headerPanel.SelectionPanelSpec.TorsoPanel.Button.onClick.Invoke();
                _headerPanel.SelectionPanelGloss.TorsoPanel.Button.onClick.Invoke();
                _headerPanel.SelectionPanelNorm.TorsoPanel.Button.onClick.Invoke();
                _headerPanel.decalButton.button.onClick.Invoke();
                _headerPanel.SelectionPanelDecal.TorsoPanel.Button.onClick.Invoke();
                //_genitalMakerPanel.Start(GetGPUTexture("_MainTex", "torso"));
                _SetupFinished = true;
                OnCoreChange(this, new PanelEventArgs("Core-SETUP FINISHED"));
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }
        private Texture[] gpuDecalArray;
        private Texture[] gpuSpecArray;
        private Texture[] gpuGlossArray;
        private Texture[] gpuDiffuseArray;
        private Texture[] gpuNormalArray;
        private void storeGPUMats()
        {
            gpuDecalArray = new Texture[_dazSkin.GPUmaterials.Length];
            gpuSpecArray = new Texture[_dazSkin.GPUmaterials.Length];
            gpuGlossArray = new Texture[_dazSkin.GPUmaterials.Length];
            gpuDiffuseArray = new Texture[_dazSkin.GPUmaterials.Length];
            gpuNormalArray = new Texture[_dazSkin.GPUmaterials.Length];
            for (int i = 0; i < _dazSkin.GPUmaterials.Length; i++)
            {
                gpuDiffuseArray[i] = _dazSkin.GPUmaterials[i].GetTexture("_MainTex");
                gpuDecalArray[i] = _dazSkin.GPUmaterials[i].GetTexture("_DecalTex");
                gpuSpecArray[i] = _dazSkin.GPUmaterials[i].GetTexture("_SpecTex");
                gpuGlossArray[i] = _dazSkin.GPUmaterials[i].GetTexture("_GlossTex");
                gpuNormalArray[i] = _dazSkin.GPUmaterials[i].GetTexture("_BumpMap");
            }
        }
        private void restoreGPUMats()
        {   //why not use .GPUmaterials[i] = DazSkinv2.dazMesh.materials[i];
            for (int i = 0; i < _dazSkin.GPUmaterials.Length; i++)
            {
                // _dazSkin.GPUmaterials[i] = _dazSkin.dazMesh.materials[i];
                //_dazSkin.CopyMaterials();
                _dazSkin.GPUmaterials[i].SetTexture("_MainTex", gpuDiffuseArray[i]);
                _dazSkin.GPUmaterials[i].SetTexture("_DecalTex", gpuDecalArray[i]);
                _dazSkin.GPUmaterials[i].SetTexture("_SpecTex", gpuSpecArray[i]);
                _dazSkin.GPUmaterials[i].SetTexture("_GlossTex", gpuGlossArray[i]);
                _dazSkin.GPUmaterials[i].SetTexture("_BumpMap", gpuNormalArray[i]);
            }
        }
        private IEnumerator CharacterChanged()
        {
            LogError("CharacterChanged");
            //used to know which character is being used or changed
            _dazCharacterSelector = _parentAtom.GetComponentInChildren<DAZCharacterSelector>();
            DAZCharacter previousDazCharacter = _dazCharacter;
            ResetOriginalGPUTextures(previousDazCharacter);
            _dazCharacter = _dazCharacterSelector.selectedCharacter;
            yield return new WaitUntil(() => _dazCharacter.ready);
            _dazSkin = (DAZMergedSkinV2)_dazCharacter.skin;
            storeGPUMats();
            _isMale = _dazCharacter.isMale;
            _uvSetName = _dazCharacter.UVname.Replace("UV: ", "");
            LogError("Waiting on UI");
            yield return new WaitUntil(() => _SetupFinished == true);
            LogError("UI should be ready");
            OnCoreChange(this, new PanelEventArgs("New Skin Selected"));
            //_headerPanel.UpdateSelectionPanels();
            if (_savedData != null)
            {
                LogError("Restore save state");
                PerformLoad(_savedData);
                _savedData = null;
            }
        }
        //called on character change or UI
        private void ResetOriginalGPUTextures(DAZCharacter dAZCharacter)
        {
            try
            {
                if (dAZCharacter == null || _dazSkin == null)
                    return;
                restoreGPUMats();
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Error resetting custom textures " + e);
            }
            //NEED TO REAPPLY CUSTOM TEXTURES
            ResetCustomTextures(_dazCharacter);
            //TempManager.DestoryAll();
        }
        //Non decal slots will get reset to BASE skin. So reapply custom skin settings
        private void ResetCustomTextures(DAZCharacter dAZCharacter)
        {
            try
            {
                if (dAZCharacter == null)
                    return;
                DAZCharacterTextureControl dAZCharacterTextureControl = dAZCharacter.GetComponentInChildren<DAZCharacterTextureControl>();
                foreach (string UrlParamName in dAZCharacterTextureControl.GetUrlParamNames())
                {
                    JSONStorableUrl jsnURL = dAZCharacterTextureControl.GetUrlJSONParam(UrlParamName);
                    if (jsnURL != null && jsnURL.val != "")
                    {
                        jsnURL.setJSONCallbackFunction(jsnURL);
                    }
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Error resetting custom JSONStorableURL" + e);
            }
        }
        private void ResetAll()
        {
            ResetOriginalGPUTextures(_dazCharacter);
            foreach (var v in _headerPanel.selectionPanels)
            {
                foreach (var selPanel in v.Value.Selections)
                {
                    int count = selPanel.Value.DecalPanels.Count;
                    for (int i = 0; i < count; i++)
                    {
                        selPanel.Value.RemoveDecalPanel();
                    }
                }
            }
        }
        public void RemoveTempDecalPanels()
        {
            _headerPanel.RemoveTempDecalPanels();
        }
        public void ResetTempDecalPanelTable()
        {
            OnCoreChange(this, new PanelEventArgs("Core-RESET TEMPDECAL"));
        }
        public void PresetLoadCallBack(string path)
        {
            PresetLoad(path);
        }
        public void PresetLoad(string path, bool temp = false, string package = null)
        {
            if (string.IsNullOrEmpty(path))
                return;
            JSONClass jc = this.LoadJSON(path) as JSONClass;
            PerformLoad(jc, temp, package, path);
        }
        public void SavePresetCallback(string path)
        {
            if (string.IsNullOrEmpty(path))
                return;
            JSONClass json = GetJSON();
            path = path.Replace(".dsgn.DecalMakerPreset", "");
            path = path + ".DecalMakerPreset.json";
            this.SaveJSON(json, path);
            SuperController.singleton.DoSaveScreenshot(path);
            SuperController.singleton.fileBrowserUI.ClearCacheImage(path);
        }
        //SAVE
        //private string DSGN = "dsgn";
        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
        {
            JSONClass jc = base.GetJSON(includePhysical, includeAppearance, true);
            jc["SaveVersion"] = "1";
            //save
            jc["Decal"] = _headerPanel.SelectionPanelDecal.Save();
            jc["Specular"] = _headerPanel.SelectionPanelSpec.Save();
            jc["Gloss"] = _headerPanel.SelectionPanelGloss.Save();
            jc["Normal"] = _headerPanel.SelectionPanelNorm.Save();
            jc["Nipple Cutouts ON"] = _toggleNippleCutout.val.ToString();
            jc["Genital Cutouts ON"] = _toggleGenitalCutout.val.ToString();
            return jc;
        }
        //LOAD 
        public override void RestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, JSONArray presetAtoms = null, bool setMissingToDefault = true)
        {
            base.RestoreFromJSON(jc, restorePhysical, restoreAppearance, presetAtoms);
            //store and call once we have everything loaded. RestorefromJSON is too early
            _savedData = jc;
        }
        //used for JSONStorableAction
        public void PerformLoad()
        {
            PerformLoad(_savedData);
        }
        private void PerformLoad(JSONClass jc, bool temp = false, string package = null, string selectedFile = null)
        {
            if (jc == null)
                return;
            //convert to new file version if save is old
            try
            {
                if (jc["SaveVersion"] == null)
                    jc = ConvertSaveToV1(jc);
                //if (jc["SaveVersion"].AsInt == 1)
                //    jc = ConvertSaveToV2(jc);
            }
            catch
            {
                SuperController.LogError("Decal Maker: Unable to convert save");
                return;
            }
            // Load Save Data
            try
            {
                _toggleNippleCutout.RestoreFromJSON(jc);
                _toggleGenitalCutout.RestoreFromJSON(jc);
                foreach (var panel in _headerPanel.selectionPanels)
                {
                    if (jc[panel.Key] != null)
                    {
                        foreach (var selPanel in panel.Value.Selections)
                        {
                            foreach (JSONClass saveJSON in jc[panel.Key][selPanel.Key] as JSONArray)
                            {
                                DecalPanel d = panel.Value.AddDecalPanel(selPanel.Key, temp);
                                if (saveJSON["Alpha"] != null)
                                {
                                    d.sliderDynamic.slider.value = (float.Parse(saveJSON["Alpha"]));
                                }
                                if (saveJSON["H"] != null)
                                {
                                    float h = float.Parse(saveJSON["H"]);
                                    float s = float.Parse(saveJSON["S"]);
                                    float v = float.Parse(saveJSON["V"]);
                                    d.jcolor.SetVal(h, s, v);
                                }
                                if (saveJSON["Path"] != null)
                                {
                                    d.RestoreImageFromJSON(saveJSON["Path"], package, selectedFile);
                                }
                            }
                        }
                    }
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Unable to Load save");
                SuperController.LogError(e.Message);
                SuperController.LogError(e.StackTrace);
                return;
            }
        }
        //upgrades old saves to new format
        private JSONClass ConvertSaveToV1(JSONClass jc)
        {
            List<string> keys = new List<string>() { "torso", "genitals", "face", "limbs" };
            JSONClass dc = new JSONClass();
            foreach (string key in keys)
            {
                if (jc[key] != null)
                {
                    dc.Add(key, jc[key]);
                }
                jc.Remove(key);
            }
            jc["Decal"] = dc;
            return jc;
        }
        private JSONClass ConvertSaveToV2(JSONClass jc)
        {
            //List<string> keys = new List<string>() { "torso", "genitals", "face", "limbs" };
            //List<string> panels = _headerPanel.selectionPanels.Keys.ToList();
            //foreach (string panel in panels)
            //{
            //    SuperController.LogError("Convert colors start" + panel);
            //    foreach (string key in keys)
            //    {
            //        foreach (JSONClass c in jc[panel][key] as JSONArray)
            //        {
            //            SuperController.LogError(c["H"] + " Convert colors **** " + c.ToString());
            //            c["DecalPanelColorPicker"]["h"] = c["H"];
            //            c["DecalPanelColorPicker"]["s"] = c["S"];
            //            c["DecalPanelColorPicker"]["v"] = c["V"];
            //            c.Remove("H");
            //            c.Remove("S");
            //            c.Remove("V");
            //        }
            //    }
            //}
            return jc;
        }
    }
    //root class that provide the basic setup and anchor for a window
    //fix this to derive
    public class BasePanel
    {
        public UIDynamic spacerLeft { get; private set; }
        public UIDynamic spacerRight { get; private set; }
        private Decal_Maker _DM;
        public BasePanel(Decal_Maker DM, int size = 550)
        {
            _DM = DM;
            //create a UI Spacers to Hold our Panels
            spacerLeft = DM.CreateSpacer(false);
            spacerLeft.height = size;
            spacerRight = DM.CreateSpacer(true);
            spacerRight.height = size;
        }
    }
    public class MyButton
    {
        public GameObject gameObject = new GameObject("MyButton");
        public Image image { get; set; }
        public Button button { get; set; }
        public Text buttonText { get; set; }
        private DefaultControls.Resources resources = new DefaultControls.Resources();
        private Color normalColor;
        private Color unselectedColor;
        public void Selected(bool value)
        {
            if (value)
            {
                ColorBlock colors = button.colors;
                colors.normalColor = normalColor;
                button.colors = colors;
            }
            else
            {
                ColorBlock colors = button.colors;
                colors.normalColor = unselectedColor;
                button.colors = colors;
            }
        }
        public MyButton(string label = "Button", Color? color = null)
        {
            //transform = gameObject.transform;
            RectTransform rt = gameObject.AddComponent<RectTransform>();
            rt.sizeDelta = new Vector2(160, 30);
            GameObject textGO = new GameObject("Text");
            textGO.transform.SetParent(gameObject.transform, false);
            RectTransform tRT = textGO.AddComponent<RectTransform>();
            tRT.anchorMin = Vector2.zero;
            tRT.anchorMax = Vector2.one;
            tRT.sizeDelta = Vector2.zero;
            buttonText = textGO.AddComponent<Text>();
            buttonText.text = label;
            buttonText.alignment = TextAnchor.MiddleCenter;
            buttonText.color = Color.black;
            buttonText.font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            buttonText.fontSize = 30;
            image = gameObject.AddComponent<Image>();
            image.material = new Material(Shader.Find("UI/Default-Overlay"));
            //image.color = color ?? Color.green;
            normalColor = color ?? new Color(0.6f, 0, 0, 1);
            button = gameObject.AddComponent<Button>();
            //convert color to HSV to allow easier lighten/darken operation
            float H, S, V;
            Color.RGBToHSV(normalColor, out H, out S, out V);
            ColorBlock colors = button.colors;
            colors.highlightedColor = Color.HSVToRGB(H, S, V * 1.4f);
            colors.normalColor = normalColor;
            colors.pressedColor = normalColor;// Color.HSVToRGB(H, S, V * 1.2f);
            unselectedColor = Color.HSVToRGB(H, S, V * 0.5f);
            button.colors = colors;
        }
        public void SetIcon(Texture2D icon)
        {
            image.material.mainTexture = icon;
        }
    }
}
//*** SourceCombiner -> original file CacheFile.cs ***
namespace VAM_Decal_Maker
{
    public class CacheFile
    {
        public string FileName { get; set; }
        public DateTime Created { get; private set; }
        public int width { get; set; }
        public int height { get; set; }
        public TextureFormat format { get; set; }
        public bool linear { get; set; } = false;
        public CacheFile(Texture2D texture, bool Linear)
        {
            FileName = string.Format(@"{0}.cache", Guid.NewGuid());
            Created = DateTime.Now;
            width = texture.width;
            height = texture.height;
            format = texture.format;
            linear = Linear;
        }
        public CacheFile(JSONArray array)
        {
            FileName = array[0];
            Created = DateTime.Parse(array[1]);
            width = array[2].AsInt;
            height = array[3].AsInt;
            format = (TextureFormat)Enum.Parse(typeof(TextureFormat), array[4]);
            linear = array[5].AsBool;
        }
        public void UpdateTime()
        {
            Created = DateTime.Now;
        }
        public void Load()
        {
        }
        public void Save()
        {
        }
    }
}
//*** SourceCombiner -> original file DecalPanel.cs ***
namespace VAM_Decal_Maker
{
    public class DecalPanel
    {
        public GameObject gameObject = new GameObject("DecalPanel");
        public ImagePanel ImagePanel { get; private set; }
        public MyButton Up { get; private set; }
        public MyButton Down { get; private set; }
        public MyButton Open { get; private set; }
        public MyButton Close { get; private set; }
        public Color Color { get { return ImagePanel.color; } }
        public JSONStorableColor jcolor { get; private set; }
        public UIDynamicSlider sliderDynamic { get; private set; }
        public Action<string> LastDir;
        public Text panelText { get; private set; }
        public event EventHandler<PanelEventArgs> DecalPanelUpdate;
        //event Handler for this class
        private void OnPanelChange(PanelEventArgs e)
        {
            if (DecalPanelUpdate != null)
            {
                DecalPanelUpdate(this, e);
            }
        }
        //events from image panel
        public void ImagePanelEventProcessor(object o, PanelEventArgs e)
        {   //add reference to this panel and pass on. Manager Panel handles operations
            e.DecalPanel = this;
            OnPanelChange(e);
        }
        private Decal_Maker _DM;
        private UIDynamicSlider CreateSlider(UnityAction<float> action, int min = 0, int max = 1, int value = 1, string title = "")
        {
            Transform sliderPrefab = GameObject.Instantiate<Transform>(_DM.manager.configurableSliderPrefab);
            sliderPrefab.SetParent(gameObject.transform, false);
            sliderPrefab.localPosition = Vector3.zero;
            sliderDynamic = sliderPrefab.GetComponent<UIDynamicSlider>();
            sliderDynamic.transform.localPosition = new Vector2(0, -80);
            sliderDynamic.quickButtonsEnabled = false;
            sliderDynamic.rangeAdjustEnabled = false;
            sliderDynamic.defaultButtonEnabled = false;
            Image sliderBackground = sliderDynamic.GetComponentsInChildren<Image>().Where(x => x.name == "Panel").First();
            Color c = sliderBackground.color;
            c.a = 0.1f;
            sliderBackground.color = c;
            sliderDynamic.slider.onValueChanged.AddListener(action);
            sliderDynamic.slider.minValue = min;
            sliderDynamic.slider.maxValue = max;
            sliderDynamic.slider.value = value;
            sliderDynamic.label = title;
            sliderDynamic.labelText.transform.localPosition += new Vector3(400, 0, 0);
            RectTransform fill = sliderDynamic.slider.fillRect;
            fill.sizeDelta += new Vector2(0, 20);
            return sliderDynamic;
        }
        public DecalPanel(Transform anchor, float width, float height, Color? color, Decal_Maker DM, bool isNormalMap = false, bool linear = false)
        {
            gameObject.transform.SetParent(anchor, false);
            _DM = DM;
            //basePanel
            Image panelImage = gameObject.AddComponent<Image>();
            panelImage.material = new Material(Shader.Find("UI/Default-Overlay"));
            panelImage.color = color ?? new Color(0, 0, 0, 0f);
            panelImage.rectTransform.sizeDelta = new Vector2(width, height);
            //Image panel
            GameObject imageObject = new GameObject("ImagePanel");
            imageObject.transform.SetParent(gameObject.transform, false);
            ImagePanel = new ImagePanel(DM, null, null, null, isNormalMap, linear);
            ImagePanel.gameObject.transform.SetParent(gameObject.transform, false);
            ImagePanel.gameObject.transform.localPosition = new Vector3(panelImage.rectTransform.rect.xMax - ImagePanel.rectTransform.rect.xMax - 10, 0, 0);
            //register for event
            ImagePanel.ImagePanelUpdate += ImagePanelEventProcessor;
            if (isNormalMap)
            {
                CreateSlider(ImagePanel.SetNormalScale, -10, 10, 1, "Normal Strength");
            }
            else if (linear)
            {
                CreateSlider(ImagePanel.SetAlpha, -10, 10, 1, "Spec/Gloss Strength").gameObject.SetActive(false);
            }
            else
            {
                CreateSlider(ImagePanel.SetAlpha, 0, 1, 1, "Alpha value");
            }
            GameObject colorObject = new GameObject("ColorPanel");
            colorObject.transform.SetParent(gameObject.transform, false);
            colorObject.transform.localScale = new Vector3(.55f, .55f, .55f);
            colorObject.transform.localPosition = new Vector2(-350, 50);
            Image colorImage = colorObject.AddComponent<Image>();
            colorImage.material = new Material(Shader.Find("UI/Default-Overlay"));
            colorImage.color = new Color(0, 1, 1, 0f);
            colorImage.rectTransform.sizeDelta = new Vector2(600, 300);
            colorImage.transform.localPosition = new Vector2(-350, 50);
            Transform colorPickerPrefab = GameObject.Instantiate<Transform>(DM.manager.configurableColorPickerPrefab);
            colorPickerPrefab.SetParent(colorImage.transform, false);
            colorPickerPrefab.localPosition = Vector3.zero;
            UIDynamicColorPicker colorPickerDynamic = colorPickerPrefab.GetComponent<UIDynamicColorPicker>();
            colorPickerDynamic.showLabel = false;
            HSVColor hsvc = HSVColorPicker.RGBToHSV(1f, 1f, 1f);
            jcolor = new JSONStorableColor("DecalPanelColorPicker", hsvc, ImagePanel.SetColor);
            jcolor.colorPicker = colorPickerDynamic.colorPicker;
            Up = new MyButton("", new Color(0.9f, 0.6f, 0.1f));
            Up.gameObject.transform.SetParent(gameObject.transform, false);
            Up.gameObject.transform.localPosition = new Vector2(-100, 50);
            RectTransform upRT = Up.gameObject.GetComponent<RectTransform>();
            upRT.sizeDelta = new Vector2(60, 60);
            byte[] tmppng = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Up-Icon.jpg");
            Texture2D UpIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            UpIcon.LoadImage(tmppng);
            Up.SetIcon(UpIcon);
            Down = new MyButton("", new Color(0.1f, 0.6f, 0.8f));
            Down.gameObject.transform.SetParent(gameObject.transform, false);
            Down.gameObject.transform.localPosition = Up.gameObject.transform.localPosition + new Vector3(65, 0, 0);
            RectTransform dwnRT = Down.gameObject.GetComponent<RectTransform>();
            dwnRT.sizeDelta = new Vector2(60, 60);
            tmppng = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Down-Icon.jpg");
            Texture2D DownIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            DownIcon.LoadImage(tmppng);
            Down.SetIcon(DownIcon);
            Close = new MyButton("");
            Close.gameObject.transform.SetParent(gameObject.transform, false);
            Close.gameObject.transform.localPosition = Down.gameObject.transform.localPosition + new Vector3(160, 0, 0);
            RectTransform clsRT = Close.gameObject.GetComponent<RectTransform>();
            clsRT.sizeDelta = new Vector2(60, 60);
            tmppng = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Close-Icon.jpg");
            Texture2D CloseIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            CloseIcon.LoadImage(tmppng);
            Close.SetIcon(CloseIcon);
            Open = new MyButton("", new Color(.7f, .7f, .7f));
            Open.gameObject.transform.SetParent(gameObject.transform, false);
            Open.gameObject.transform.localPosition = Up.gameObject.transform.localPosition + new Vector3(-65, 0, 0);
            RectTransform opnRT = Open.gameObject.GetComponent<RectTransform>();
            opnRT.sizeDelta = new Vector2(60, 60);
            tmppng = FileManagerSecure.ReadAllBytes(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/Open-Icon.jpg");
            Texture2D OpenIcon = new Texture2D(1, 1, TextureFormat.RGBA32, false);
            OpenIcon.LoadImage(tmppng);
            Open.SetIcon(OpenIcon);
            //Texture Path Text
            GameObject textObject = new GameObject("textPanel");
            textObject.transform.SetParent(gameObject.transform, false);
            //used to prevent text object from blocking clicks
            CanvasGroup cg = textObject.AddComponent<CanvasGroup>();
            cg.blocksRaycasts = false;
            panelText = textObject.AddComponent<Text>();
            panelText.alignment = TextAnchor.LowerLeft;
            panelText.color = Color.black;
            panelText.font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            panelText.fontSize = 30;
            panelText.fontStyle = FontStyle.Bold;
            RectTransform ptRT = panelText.GetComponent<RectTransform>();
            ptRT.sizeDelta = new Vector2(width, height);
            ptRT.localPosition = new Vector2(40, 40);
            panelText.text = "Click White Square to select image.-->";
            Up.button.onClick.AddListener(() =>
            {
                OnPanelChange(new PanelEventArgs("DecalPanel-Move-UP", this));
            });
            Down.button.onClick.AddListener(() =>
            {
                OnPanelChange(new PanelEventArgs("DecalPanel-Move-DOWN", this));
            });
            Close.button.onClick.AddListener(() =>
            {
                OnPanelChange(new PanelEventArgs("DecalPanel-DELETE", this));
            });
            Open.button.onClick.AddListener(() =>
            {
                OnPanelChange(new PanelEventArgs("DecalPanel-CREATE", this));
            });
        }
        public void SetPathText(string text)
        {
            //count char back to first slash
            int lastIndex = text.LastIndexOf("/");
            if (text.Length > 55 && lastIndex >= 0)
            {
                string endText = text.Substring(lastIndex);
                int leftover = 55 - endText.Length + 3;
                string startText = text.Substring(0, leftover);
                text = startText + "..." + endText;
            }
            panelText.text = text;
        }
        //Used to correct paths in JSON to available VAR files until VAM expands FileManagerSecure
        //this is a nasty fucking mess
        //path = image path package
        public void RestoreImageFromJSON(string path, string package = null, string selectedFile = null)
        {
            try
            {
                path = FileManagerSecure.NormalizePath(path);
                Match m;
                //VAR Path for textures with direct var ref
                if ((m = Regex.Match(path, "^(.+\\..+)\\.(.+):/(.+/)(.+)")).Success)
                {
                    //this is a packagedVAR reference use latest version
                    string varName = m.Groups[1].Value;
                    string filePath = m.Groups[3].Value;
                    string fileName = m.Groups[4].Value;
                    ShortCut sc = FileManagerSecure.GetShortCutsForDirectory(filePath).Where(x => x.package.Contains(varName) && x.isLatest).FirstOrDefault();
                    //if nothing found with this path
                    if (sc == null)
                    {
                        SuperController.LogError("Decal Maker: Texture not found: " + path);
                        return;
                    }
                    path = Regex.Replace(sc.path, "^.+/(.+\\..+\\..+)\\..+(:.+)", "$1$2/" + fileName); //removes AddonPackages/ path prefix and the .var from shortcut path
                }
                //if texture and presets are in same VAR  VAM changes all paths to SELF:
                //prefabs UI passes in a package ref
                else if ((m = Regex.Match(path, "^SELF:.+")).Success && package != null)
                {   //SELF:/Custom/Atom/Person/Textures/DecalMaker - mofmes power goo/Face/Cheeks/face04/D.png
                    path = Regex.Replace(path, "^(SELF)(:.+)", package + "$2"); //replace SELF:/ with source package
                }
                else if ((m = Regex.Match(path, "^SELF:.+")).Success && selectedFile != null)
                {
                    if ((m = Regex.Match(selectedFile, "^(.+\\..+\\..+):.+")).Success)
                    {
                        string varName = m.Groups[1].Value;
                        path = Regex.Replace(path, "^(SELF)(:.+)", varName + "$2"); //replace SELF:/ with source package
                    }
                }
                //no fing clue. We have to find it
                else if ((m = Regex.Match(path, "^SELF:.+")).Success)
                {
                    //Find the first package with this path
                    path = Regex.Replace(path, "^SELF:/(.+/)", "$1");
                    string pathWithoutFileName = Regex.Replace(path, "^(.+/).+", "$1");
                    List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory(pathWithoutFileName);
                    foreach (ShortCut s in shortCuts)
                    {
                        if (s.isLatest && s.package != "" && s.package != "AddonPackages Flattened" && s.package != "AddonPackages Filtered")
                        {
                            List<string> files = _DM.GetFilesAtPathRecursive(s.path, null);
                            foreach (string f in files)
                            {
                                string t = FileManagerSecure.NormalizePath(f);
                                if (t.Contains(path))
                                {
                                    path = t;
                                    break;
                                }
                            }
                        }
                    }
                }
                BrowserCallBack(path);
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker: Unable to Resove Texture Path");
                SuperController.LogError(e.InnerException.StackTrace);
            }
        }
        public void BrowserCallBack(string path)
        {
            if (string.IsNullOrEmpty(path))
            {
                SetPathText("");
            }
            else
            {
                SetPathText(path);
                ImagePanel.LoadPNG(path, ImagePanel);
            }
        }
        public JSONClass Save()
        {
            JSONClass decalSaveJSON = new JSONClass();
            decalSaveJSON["H"].AsFloat = jcolor.val.H;
            decalSaveJSON["S"].AsFloat = jcolor.val.S;
            decalSaveJSON["V"].AsFloat = jcolor.val.V;
            decalSaveJSON["Alpha"].AsFloat = ImagePanel.sliderValue;
            //SuperController.LogError("ALPHA IS " + ImagePanel.sliderValue);
            //jcolor.StoreJSON(decalSaveJSON, true, true, true);
            if (!string.IsNullOrEmpty(ImagePanel.Path))
            {
                string relativePath = FileManagerSecure.NormalizePath(ImagePanel.Path);
                decalSaveJSON["Path"] = relativePath;
            }
            return decalSaveJSON;
        }
    }
}
//*** SourceCombiner -> original file HeaderPanel.cs ***
namespace VAM_Decal_Maker
{
    public class HeaderPanel
    {
        public GameObject gameObject = new GameObject("Header");
        public SelectionPanel ActivePanel { get; set; }
        public SelectionPanel SelectionPanelDecal { get; private set; }
        public SelectionPanel SelectionPanelSpec { get; private set; }
        public SelectionPanel SelectionPanelGloss { get; private set; }
        public SelectionPanel SelectionPanelNorm { get; private set; }
        public MyButton decalButton { get; private set; }
        public MyButton specButton { get; private set; }
        public MyButton glossButton { get; private set; }
        public MyButton normButton { get; private set; }
        public MyButton previewButton { get; private set; }
        private List<MyButton> buttons { get; set; }
        public Dictionary<string, SelectionPanel> selectionPanels { get; private set; }
        private Decal_Maker _DM;
        private BasePanel _basePanel;
        private bool ShowPreviewPanel = false;
        private UIDynamic spacerLeft { get { return _basePanel.spacerLeft; } }
        private UIDynamic spacerRight { get { return _basePanel.spacerRight; } }
        public HeaderPanel(Decal_Maker DM)
        {
            _DM = DM;
            _basePanel = new BasePanel(DM, 50);
            //Image i = spacerLeft.gameObject.AddComponent<Image>();
            //i.material = new Material(Shader.Find("UI/Default-Overlay"));
            //i.material.color = Color.green;
            gameObject.transform.SetParent(spacerLeft.transform, false);
            //center panel in UI
            gameObject.transform.localPosition += new Vector3(270, 10, 0);
            //basePanel
            Image panelImage = gameObject.AddComponent<Image>();
            panelImage.material = new Material(Shader.Find("UI/Default-Overlay"));
            panelImage.color = new Color(.5f, .5f, .5f, 1);
            panelImage.rectTransform.sizeDelta = new Vector2(1050, 70);
            GridLayoutGroup glg = gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(200, 50);
            glg.constraint = GridLayoutGroup.Constraint.FixedRowCount;
            glg.constraintCount = 1;
            glg.padding = new RectOffset(10, 10, 10, 10);
            glg.spacing = new Vector2(10, 0);
            decalButton = new MyButton("Decal", new Color(1, 0.3f, 0.4f));
            decalButton.gameObject.transform.SetParent(gameObject.transform, false);
            specButton = new MyButton("Specular", new Color(0.95f, 0.25f, 0.91f));
            specButton.gameObject.transform.SetParent(gameObject.transform, false);
            glossButton = new MyButton("Gloss", new Color(0.2f, .98f, 0.2f));
            glossButton.gameObject.transform.SetParent(gameObject.transform, false);
            normButton = new MyButton("Normal", new Color(0.2f, 0.9f, .9f));
            normButton.gameObject.transform.SetParent(gameObject.transform, false);
            //previewButton = new MyButton("Preview", new Color(0.2f, 0.6f, 0.8f));
            //previewButton.gameObject.transform.SetParent(gameObject.transform, false);
            //previewButton.button.onClick.AddListener(() =>
            //{
            //    ShowPreviewPanel = !ShowPreviewPanel;
            //    DM._previewAnchor.gameObject.SetActive(ShowPreviewPanel);
            //});
            buttons = new List<MyButton>() { decalButton, specButton, glossButton, normButton };
            SelectionPanelDecal = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = "_DecalTex",
                isNormalMap = false,
                linear = false
            };
            SelectionPanelSpec = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = "_SpecTex",
                isNormalMap = false,
                linear = true
            };
            SelectionPanelGloss = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = "_GlossTex",
                isNormalMap = false,
                linear = true
            };
            SelectionPanelNorm = new SelectionPanel(1050, 300, new Color(1, 1, 1, 1f), DM)
            {
                MaterialSlot = "_BumpMap",
                isNormalMap = true,
                linear = true
            };
            //now finalize panels
            SelectionPanelDecal.CreatePanels();
            SelectionPanelSpec.CreatePanels();
            SelectionPanelGloss.CreatePanels();
            SelectionPanelNorm.CreatePanels();
            SelectionPanelDecal.PanelName = "Decal";
            SelectionPanelSpec.PanelName = "Specular";
            SelectionPanelGloss.PanelName = "Gloss";
            SelectionPanelNorm.PanelName = "Normal";
            SelectionPanelDecal.ActivateWindow(true);
            SelectionPanelSpec.ActivateWindow(false);
            SelectionPanelGloss.ActivateWindow(false);
            SelectionPanelNorm.ActivateWindow(false);
            ActivePanel = SelectionPanelDecal;
            selectionPanels = new Dictionary<string, SelectionPanel> { { "Decal", SelectionPanelDecal }, { "Specular", SelectionPanelSpec }, { "Gloss", SelectionPanelGloss }, { "Normal", SelectionPanelNorm } };
            foreach (MyButton uB in buttons)
            {
                uB.button.onClick.AddListener(() =>
                {
                    foreach (MyButton b in buttons)
                    {
                        if (b.buttonText == uB.buttonText)
                        {
                            b.Selected(true);
                            ActivePanel = selectionPanels[b.buttonText.text];
                            ActivePanel.ActivateWindow(true);
                        }
                        else
                        {
                            b.Selected(false);
                            ActivePanel = selectionPanels[b.buttonText.text];
                            ActivePanel.ActivateWindow(false);
                        }
                    }
                });
            }
        }
        public void RemoveTempDecalPanels()
        {
            SelectionPanelDecal.RemoveTempDecalPanels();
            SelectionPanelSpec.RemoveTempDecalPanels();
            SelectionPanelGloss.RemoveTempDecalPanels();
            SelectionPanelNorm.RemoveTempDecalPanels();
        }
    }
}
//*** SourceCombiner -> original file ImagePanel.cs ***
namespace VAM_Decal_Maker
{
    public class ImagePanel
    {
        public GameObject gameObject = new GameObject("ImagePanel");
        //We now have multiple slider types Alpha and NormalMap so centralize the value
        public float sliderValue { get; private set; } = 1f;
        public string imageHash { get; private set; }
        public bool ImageLoading { get; private set; }
        public string Path { get; set; }
        public Button Button { get; private set; }
        public string TextureSlot { get; private set; }
        public string MaterialSlot { get; private set; }
        //tell VAM image system how the texture should be loaded
        public bool isNormalMap { get; private set; }
        public bool linear { get; private set; }
        //isolate image from direct access since imagepanel sometimes modifies the image shader or image so use imagePanels properties not the image's
        public Color color { get; private set; } = Color.white;
        public Texture mainTexture { get { return image.mainTexture; } }
        public Material material { get { return image.material; } }
        public RectTransform rectTransform { get { return image.GetComponent<RectTransform>(); } }
        public event EventHandler<PanelEventArgs> ImagePanelUpdate;
        private Image image;
        private Decal_Maker _DM;
        private void OnImagePanelChange(PanelEventArgs e)
        {
            if (ImagePanelUpdate != null)
            {
                //store a ref to this imagepanel
                e.ImagePanel = this;
                ImagePanelUpdate(this, e);
            }
        }
        public ImagePanel(Decal_Maker DM = null, Color? color = null, string textureSlot = null, string materialSlot = null, bool setNormalMap = false, bool setLinear = false)
        {
            _DM = DM;
            TextureSlot = textureSlot;
            MaterialSlot = materialSlot;
            isNormalMap = setNormalMap;
            linear = setLinear;
            image = gameObject.AddComponent<Image>();
            image.material = new Material(Shader.Find("UI/Default-Overlay"));
            UpdateMaterialColor(color ?? new Color(1, 1, 1, 1f));
            RectTransform imageRect = image.rectTransform;
            imageRect.sizeDelta = new Vector2(300, 300);
            Button = gameObject.AddComponent<Button>();
            Button.onClick.AddListener(() =>
            {
                OnImagePanelChange(new PanelEventArgs("ImagePanel-PathChange"));
            });
        }
        public void SetNormalScale(float value)
        {
            sliderValue = value;
            //SuperController.LogError("_NormalScale " + value + " " + image.material.GetFloat("_NormalScale"));
            Material mat = new Material(_DM._customUINormalMapShader);
            mat.SetFloat("_NormalScale", value);
            mat.mainTexture = image.mainTexture;
            GameObject.Destroy(image.material);
            image.material = mat;
            OnImagePanelChange(new PanelEventArgs(mat));
        }
        public void SetSpecularScale(float value)
        {
            sliderValue = value;
            Material mat = new Material(_DM._customSpecGlossShader);
            mat.SetFloat("_Smoothness", value);
            mat.mainTexture = image.mainTexture;
            GameObject.Destroy(image.material);
            image.material = mat;
            OnImagePanelChange(new PanelEventArgs(mat));
        }
        public void SetAlpha(float value)
        {
            sliderValue = value;
            Color newAlpha = this.color;// image.material.GetColor("_Color");
            newAlpha.a = value;
            UpdateMaterialColor(newAlpha);
        }
        public void SetColor(JSONStorableColor jcolor)
        {
            Color newColor = jcolor.colorPicker.currentColor;
            //use alpha from slider
            newColor.a = this.color.a;
            UpdateMaterialColor(newColor);
        }
        //cleanup
        public void OnDestroy()
        {
            GameObject.Destroy(mainTexture);
            GameObject.Destroy(material);
        }
        private void UpdateMaterialColor(Color color)
        {
            this.color = color;
            UpdateMaterialColor();
        }
        private void UpdateMaterialColor()
        {
            //The Mask object causes a modified material to be returned so it is no longer rendering the texture that you are updating with the "material" property.
            image.materialForRendering.SetColor("_Color", color);
            //update unmasked material as well
            image.material.SetColor("_Color", color);
            OnImagePanelChange(new PanelEventArgs(color));
        }
        private void UpdateMaterialTexture(Texture2D tex)
        {
            //The Mask object causes a modified material to be returned so it is no longer rendering the texture that you are updating with the "material" property.
            image.materialForRendering.SetTexture("_MainTex", tex);
            //update unmasked material as well
            image.material.SetTexture("_MainTex", tex);
        }
        public void ClearTexture()
        {
            UnityEngine.Object.Destroy(image.material);
            image.material = new Material(Shader.Find("UI/Default-Overlay"));
            OnImagePanelChange(new PanelEventArgs(material));
        }
        //Use existing texture
        public void ApplyTexture(Texture2D texture)
        {
            Material material = new Material(Shader.Find("UI/Default-Overlay"));
            material.SetTexture("_MainTex", texture);
            UnityEngine.Object.Destroy(image.material);
            image.material = material;
            image.material.mainTexture = texture;
            OnImagePanelChange(new PanelEventArgs(this.material));
        }
        //load texture from disk
        private void OnImageLoaded(ImageLoaderThreaded.QueuedImage qi)
        {
            if (qi != null)
            {
                //create new material instance so we can change texture seperatly
                if (isNormalMap)
                {
                    image.material = new Material(_DM._customUINormalMapShader);
                }
                else
                {
                    image.material = new Material(Shader.Find("UI/Default-Overlay"));
                }
                image.material.mainTexture = qi.tex;
                UpdateMaterialColor();
                Path = qi.imgPath;
                imageHash = ComputeImagehash(qi.tex);
                ImageLoading = false;
                OnImagePanelChange(new PanelEventArgs(material));
            }
        }
        private string ComputeImagehash(Texture2D tex)
        {
            if (tex == null)
                return "ERROR";
            byte[] raw = tex.GetRawTextureData();
            using (MD5 md5 = MD5.Create())
            {
                byte[] bytes = md5.ComputeHash(raw);
                StringBuilder builder = new StringBuilder(bytes.Length * 2);
                for (int i = 0; i < bytes.Length; i++)
                {
                    builder.Append(bytes[i].ToString("x2"));
                }
                return builder.ToString();
            }
        }
        //Old VAM version does not give access to load texture so use VAM image loading routine instead
        //Newer can use FileManagementSecure.FileManagerSecure or loadTexture
        //Wil call OnImageLoad once finished   
        public void LoadPNG(string filePath, ImagePanel callBack)
        {
            ImageLoaderThreaded.QueuedImage queuedImage = new ImageLoaderThreaded.QueuedImage();
            queuedImage.imgPath = filePath;
            queuedImage.forceReload = false;
            queuedImage.createMipMaps = false;
            queuedImage.isNormalMap = isNormalMap;
            queuedImage.isThumbnail = false;
            queuedImage.linear = linear;
            queuedImage.createAlphaFromGrayscale = false;
            queuedImage.compress = false;//!queuedImage.isNormalMap;
            queuedImage.callback = new ImageLoaderThreaded.ImageLoaderCallback(callBack.OnImageLoaded); // = new ImageLoaderThreaded.ImageLoaderCallback(OnImageLoaded);
            //start image load
            ImageLoaderThreaded.singleton.QueueImage(queuedImage);
            ImageLoading = true;
        }
    }
}
//*** SourceCombiner -> original file JSONStorableDecalPanel.cs ***
namespace VAM_Decal_Maker
{
    public class JSONStorableDecalPanel : JSONStorableParam
    {
        public JSONStorableDecalPanel()
        {
        }
        public override bool StoreJSON(JSONClass jc, bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
        {
            return true;
        }
        public override void RestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
        {
        }
        public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
        {
            throw new NotImplementedException();
        }
        public override void SetDefaultFromCurrent()
        {
            throw new NotImplementedException();
        }
        public override void SetValToDefault()
        {
            throw new NotImplementedException();
        }
    }
}
//*** SourceCombiner -> original file ManagerPanel.cs ***
namespace VAM_Decal_Maker
{
    //Controls the display of Decal Level UI elements
    //split off from ImagePanel to focus class
    public class ManagerPanel
    {
        public ImagePanel ImagePanel { get; set; }
        public GameObject gameObject { get { return ImagePanel.gameObject; } }
        //public Image image { get { return imagePanel.image; } set { imagePanel.image = value; } }
        public Texture mainTexture { get { return ImagePanel.mainTexture; } }
        public string imageHash { get { return ImagePanel.imageHash; } }
        public bool ImageLoading { get { return ImagePanel.ImageLoading; } }
        public string Path { get { return ImagePanel.Path; } }
        public Button Button { get { return ImagePanel.Button; } }
        public string TextureSlot { get { return ImagePanel.TextureSlot; } }
        public string MaterialSlot { get { return ImagePanel.MaterialSlot; } }
        //tell VAM image system how the texture should be loaded
        public bool isNormalMap { get { return ImagePanel.isNormalMap; } }
        public bool linear { get { return ImagePanel.linear; } }
        //controls the addition and removal of all panels
        public List<DecalPanel> DecalPanels { get; set; } = new List<DecalPanel>();
        private List<DecalPanel> TempDecalPanels { get; set; } = new List<DecalPanel>();
        public UIDynamic spacerLeft { get; private set; }
        public UIDynamic spacerRight { get; private set; }
        public event EventHandler<PanelEventArgs> ManagerPanelUpdate;
        private Decal_Maker _DM;
        private string _lastDir = "Custom/Atom/Person/Textures";
        public RenderPanelBase renderPanel { get; set; }
        private RenderPanelNormal SelfNormRenderPanel;
        //events for this class
        private void OnManagerPanelChange(object o, PanelEventArgs e)
        {
            if (ManagerPanelUpdate != null)
            {
                e.ManagerPanel = this;
                ManagerPanelUpdate(this, e);
            }
        }
        //events from decal panel
        private void DecalPanelEvent(object o, PanelEventArgs e)
        {
            int currentIndex;
            int newIndex;
            if (renderPanel != null)
            {
                switch (e.EventName)
                {
                    case "Create":
                        renderPanel.IsDirty = true;
                        break;
                    case "Color":
                        renderPanel.IsDirty = true;
                        break;
                    case "DecalPanelMove":
                        RepositionDecalPanel(e.DecalPanel, e.NewPosition);
                        renderPanel.IsDirty = true;
                        break;
                    case "DecalPanel-Move-UP":
                        currentIndex = e.DecalPanel.gameObject.transform.GetSiblingIndex();
                        newIndex = currentIndex - 1;
                        if (newIndex >= 0)
                        {
                            RepositionDecalPanel(e.DecalPanel, newIndex);
                            renderPanel.IsDirty = true;
                        }
                        break;
                    case "DecalPanel-Move-DOWN":
                        currentIndex = e.DecalPanel.gameObject.transform.GetSiblingIndex();
                        newIndex = currentIndex + 1;
                        if (newIndex < DecalPanels.Count)
                        {
                            RepositionDecalPanel(e.DecalPanel, newIndex);
                            renderPanel.IsDirty = true;
                        }
                        break;
                    case "DecalPanel-CREATE":
                        DecalPanel d = AddDecalPanels();
                        currentIndex = e.DecalPanel.gameObject.transform.GetSiblingIndex();
                        newIndex = currentIndex + 1;
                        RepositionDecalPanel(d, newIndex);
                        renderPanel.IsDirty = true;
                        break;
                    case "DecalPanel-DELETE":
                        RemoveDecalPanel(e.DecalPanel);
                        e.DecalPanel.ImagePanel.OnDestroy();
                        renderPanel.IsDirty = true;
                        break;
                    case "ImagePanel-PathChange":
                        if (_lastDir == null)
                        {
                            _lastDir = "Custom/Atom/Person/Textures";
                        }
                        List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory("Custom/Atom/Person/Textures/", false, true, true, false);
                        SuperController.singleton.GetMediaPathDialog(new FileBrowserCallback(e.DecalPanel.BrowserCallBack), "", _lastDir, true, true, false, null, false, shortCuts);
                        break;
                    default:
                        //SuperController.LogError("OPERATION NOT HANDLED" + e.EventName);
                        renderPanel.IsDirty = true;
                        break;
                }
            }
            OnManagerPanelChange(this, e);
        }
        //events from Core
        private void CoreEvent(object o, PanelEventArgs e)
        {
            switch (e.EventName)
            {
                case "Core-SETUP FINISHED":
                    break;
                case "Core-RESET TEMPDECAL":
                    ResetTempDecalPanelTable();
                    break;
                case "Core-REMOVE TEMPDECAL":
                    ResetTempDecalPanelTable();
                    break;
                case "New Skin Selected":
                    UpdateSkinImage();
                    renderPanel.IsDirty = true;
                    break;
                case "_toggleGenitalCutout":
                    if (MaterialSlot == "_DecalTex" && TextureSlot == "genitals")
                    {
                        renderPanel.IsDirty = true;
                    }
                    break;
                case "_toggleNippleCutout":
                    if (MaterialSlot == "_DecalTex" && TextureSlot == "torso")
                    {
                        renderPanel.IsDirty = true;
                    }
                    break;
            }
        }
        private void UpdateSkinImage()
        {
            //System.Diagnostics.Stopwatch watch = System.Diagnostics.Stopwatch.StartNew();
            Texture2D temp = null;
            if (MaterialSlot == "_DecalTex")
            {
                temp = SelfNormRenderPanel.GetGPUTexture("_MainTex", TextureSlot);
            }
            else if (MaterialSlot == "_BumpMap")
            {   //convert any packed normals to rgb format
                temp = SelfNormRenderPanel.GetGPUTexture(MaterialSlot, TextureSlot);
                if (temp == null)
                    temp = SelfNormRenderPanel.BlankNormalTex;
                temp = SelfNormRenderPanel.ConvertNormal(temp);
            }
            else
            {
                temp = SelfNormRenderPanel.GetGPUTexture(MaterialSlot, TextureSlot);
            }
            ImagePanel.ApplyTexture(temp);
           // watch.Stop();
            //SuperController.LogError(MaterialSlot + " " +TextureSlot + " Skin panel took " + watch.ElapsedMilliseconds);
        }
        public ManagerPanel(Decal_Maker DM = null, Color? color = null, string textureSlot = null, string materialSlot = null, bool setNormalMap = false, bool setLinear = false)
        {
            _DM = DM;
            ImagePanel = new ImagePanel(DM, color, textureSlot, materialSlot, setNormalMap, setLinear);
            GameObject textObject = new GameObject("Region Text");
            textObject.AddComponent<RectTransform>();
            textObject.transform.SetParent(gameObject.transform, false);
            textObject.transform.localPosition = new Vector3(0, -35, 0);
            Text text = textObject.AddComponent<Text>();
            text.text = textureSlot.ToUpper() ?? "";
            text.alignment = TextAnchor.LowerCenter;
            text.color = new Color(0.196078435f, 0.196078435f, 0.196078435f, 1f);
            text.font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            text.fontStyle = FontStyle.Bold;
            text.fontSize = 30;
            RectTransform component = textObject.GetComponent<RectTransform>();
            component.anchorMin = Vector2.zero;
            component.anchorMax = Vector2.one;
            component.sizeDelta = Vector2.zero;
            spacerLeft = DM.CreateSpacer(false);
            spacerLeft.height = 300;
            spacerRight = DM.CreateSpacer(true);
            spacerRight.height = 300;
            //Image i = spacerLeft.gameObject.AddComponent<Image>();
            //i.material = new Material(Shader.Find("UI/Default-Overlay"));
            //i.material.color = Color.red;
            GridLayoutGroup glg = spacerLeft.gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(1050, spacerLeft.height);
            glg.constraint = GridLayoutGroup.Constraint.FixedColumnCount;
            glg.constraintCount = 1;
            //glg.padding = new RectOffset(10, 10, 10, 10);
            glg.spacing = new Vector2(0, 0);
            RemoveDecalPanel();
            ActivateWindow(false);
            //Transform parent = DM._previewAnchor.gameObject.transform;
            switch (materialSlot)
            {
                case "_DecalTex":
                    renderPanel = new RenderPanelDecal(DM, materialSlot, textureSlot);
                    break;
                case "_BumpMap":
                    renderPanel = new RenderPanelNormal(DM, materialSlot, textureSlot);
                    break;
                case "_SpecTex":
                case "_GlossTex":
                    renderPanel = new RenderPanelSpecGloss(DM, materialSlot, textureSlot);
                    break;
            }
            renderPanel.DecalPanels = DecalPanels;
            DM.CoreEvent += CoreEvent;
            SelfNormRenderPanel = new RenderPanelNormal(_DM, MaterialSlot, TextureSlot);
        }
        public DecalPanel AddDecalPanels(bool temp = false)
        {
            DecalPanel d = new DecalPanel(spacerLeft.transform, 1050, 300, UnityEngine.Random.ColorHSV(0f, 1f, 1f, 1f, 0.5f, 1f), _DM, isNormalMap, linear);
            d.gameObject.transform.localPosition += new Vector3(270, 0, 0);
            IncreaseDecalPanel(d, temp);
            renderPanel.IsDirty = true;
            return d;
        }
        public void IncreaseDecalPanel(DecalPanel d, bool temp = false)
        {
            DecalPanels.Add(d);
            ResizeSpacers(300);
            if (temp)
            {
                TempDecalPanels.Add(d);
            }
            d.DecalPanelUpdate += DecalPanelEvent;
        }
        public void RemoveDecalPanel()
        {
            if (DecalPanels.Any())
            {
                //get last entry and remove
                DecalPanel d = DecalPanels[DecalPanels.Count - 1];
                RemoveDecalPanel(d);
                renderPanel.IsDirty = true;
            }
        }
        public void RemoveDecalPanel(DecalPanel d)
        {
            bool removed = DecalPanels.Remove(d);
            if (removed)
            {
                OnManagerPanelChange(this, new PanelEventArgs("Delete", d));
                d.DecalPanelUpdate -= DecalPanelEvent;
                GameObject.Destroy(d.gameObject);
                ResizeSpacers(-300);
            }
        }
        public IEnumerator RemoveTempDecalPanels()
        {
            foreach (DecalPanel d in TempDecalPanels.ToList())
            {
                yield return new WaitWhile(() => false);
                RemoveDecalPanel(d);
            }
        }
        public void ResetTempDecalPanelTable()
        {
            TempDecalPanels = new List<DecalPanel>();
        }
        public void RepositionDecalPanel(DecalPanel d, int index)
        {
            d.gameObject.transform.SetSiblingIndex(index);
            DecalPanels.Remove(d);
            DecalPanels.Insert(index, d);
        }
        private void ResizeSpacers(float value)
        {
            spacerLeft.height += value;
            spacerRight.height += value;
        }
        public void ActivateWindow(bool value)
        {
            spacerLeft.gameObject.SetActive(value);
            spacerRight.gameObject.SetActive(value);
        }
    }
}
//*** SourceCombiner -> original file PanelEventArgs.cs ***
namespace VAM_Decal_Maker
{
    //class that creates a custom eventArgs to be sent with events
    public class PanelEventArgs : EventArgs
    {
        public PanelEventArgs(string EventName)
        {
            this.EventName = EventName;
        }
        public PanelEventArgs(string EventName, bool Value)
        {
            this.EventName = EventName;
        }
        public PanelEventArgs(string EventName, string Path)
        {
            this.EventName = EventName;
            this.Path = Path;
        }
        public PanelEventArgs(Material Material)
        {
            EventName = "Material";
            this.Material = Material;
        }
        public PanelEventArgs(Color Color)
        {
            EventName = "Color";
            this.Color = Color;
        }
        public PanelEventArgs(string EventName, DecalPanel d)
        {
            this.EventName = EventName;
            DecalPanel = d;
        }
        public PanelEventArgs(string eventName, List<DecalPanel> DecalPanels)
        {
            EventName = eventName;
            this.DecalPanels = DecalPanels;
        }
        public List<DecalPanel> DecalPanels { get; }
        public string EventName { get; }
        public Material Material { get; }
        public Color Color { get; }
        public DecalPanel DecalPanel { get; set; }
        public ImagePanel ImagePanel { get; set; }
        public ManagerPanel ManagerPanel { get; set; }
        public SelectionPanel SelectionPanel { get; set; }
        public int NewPosition { get; set; }
        public bool Value { get; set; }
        public string Path { get; set; }
    }
}
//*** SourceCombiner -> original file PrefabCollection.cs ***
namespace VAM_Decal_Maker
{
    public class PrefabCollection
    {
        public string Author { get; private set; }
        public string ItemType { get; private set; }
        public string ItemName { get; private set; }
        public string Path { get; private set; }
        public string Package { get; private set; }
        public string ImagePath { get; private set; }
        public PrefabCollection(string path, string package = null)
        {
            string fileName = GetFileName(path);
            Path = path;
            Package = package;
            MatchCollection mc = Regex.Matches(fileName, "^(.*)_(.*)_(.*).dsgn.DecalMakerPreset.json");
            foreach (Match m in mc)
            {
                Author = m.Groups[1].Value;
                ItemType = m.Groups[2].Value;
                ItemName = m.Groups[3].Value;
                string imagePath = path.Replace(".json", ".jpg");
                if (FileManagerSecure.FileExists(imagePath))
                {
                    ImagePath = imagePath;
                }
            }
        }
        //from C# PATH
        private char[] sep = new char[] { '/', '\\' };
        private string GetFileName(string path)
        {
            int num = path.LastIndexOfAny(sep);
            if (num >= 0)
            {
                return path.Substring(num + 1);
            }
            return path;
        }
    }
}
//*** SourceCombiner -> original file PrefabPanel.cs ***
namespace VAM_Decal_Maker
{
    public class PrefabPanel
    {
        public GameObject gameObject = new GameObject("PresetPanel");
        public ImagePanel ImagePanel { get; private set; }
        private Dictionary<string, List<PrefabCollection>> prefabFiles = new Dictionary<string, List<PrefabCollection>>();
        private Decal_Maker _DM;
        private BasePanel _basePanel;
        private UIDynamic spacerLeft { get { return _basePanel.spacerLeft; } }
        private UIDynamic spacerRight { get { return _basePanel.spacerRight; } }
        private string selectedType;
        private string selectedItem;
        private List<string> author = new List<string>();
        private List<string> prefabTypes = new List<string>();
        private List<string> prefabNames = new List<string>();
        private JSONStorableStringChooser jsc;
        private JSONStorableStringChooser jsc2;
        public PrefabPanel(Decal_Maker DM)
        {
            _DM = DM;
            _basePanel = new BasePanel(DM);
            ImagePanel = new ImagePanel();
            ImagePanel.gameObject.transform.SetParent(spacerRight.transform, false);
            RectTransform imageRect = ImagePanel.rectTransform;
            imageRect.sizeDelta = new Vector2(500, 500);
            GridLayoutGroup glg = spacerLeft.gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(500, 100);
            glg.constraint = GridLayoutGroup.Constraint.FixedColumnCount;
            glg.constraintCount = 1;
            glg.padding = new RectOffset(10, 10, 10, 10);
            glg.spacing = new Vector2(10, 0);
            Transform popupPrefabType = GameObject.Instantiate<Transform>(_DM.manager.configurableScrollablePopupPrefab);
            popupPrefabType.SetParent(spacerLeft.gameObject.transform, false);
            popupPrefabType.localPosition = Vector3.zero;
            UIDynamicPopup dynamicPopupType = popupPrefabType.GetComponent<UIDynamicPopup>();
            dynamicPopupType.name = "CLASS";
            //popupToJSONStorableStringChooser.Add(PrefabType, jsc);
            jsc = new JSONStorableStringChooser("name", prefabTypes, "", "Choose Type");
            jsc.popup = dynamicPopupType.popup;
            Transform popupPrefabItem = GameObject.Instantiate<Transform>(_DM.manager.configurableScrollablePopupPrefab);
            popupPrefabItem.SetParent(spacerLeft.gameObject.transform, false);
            popupPrefabItem.localPosition = Vector3.zero;
            UIDynamicPopup dynamicPopupItem = popupPrefabItem.GetComponent<UIDynamicPopup>();
            dynamicPopupItem.name = "ITEM";
            dynamicPopupItem.popup.showSlider = false;
            RefreshPrefabCollection();
            jsc2 = new JSONStorableStringChooser("name", prefabNames, "", "Choose Prefab");
            jsc2.popup = dynamicPopupItem.popup;
            dynamicPopupType.popup.onValueChangeUnityEvent.AddListener(TypeValueChanges);
            dynamicPopupItem.popup.onValueChangeUnityEvent.AddListener(ItemValueChanged);
            ImagePanel.Button.onClick.AddListener(() =>
            {
                _DM.ResetTempDecalPanelTable();
            });
            GameObject imageObject = new GameObject("text background");
            imageObject.transform.SetParent(ImagePanel.gameObject.transform, false);
            Image ima = imageObject.AddComponent<Image>();
            ima.color = new Color(.8f, .8f, .8f);
            RectTransform imRT = imageObject.GetComponent<RectTransform>();
            imageObject.transform.localPosition += new Vector3(0, -5f, 0);
            imRT.anchorMin = Vector2.zero;
            imRT.anchorMax = new Vector2(1, 0.1f);
            imRT.sizeDelta = Vector2.zero;
            //Button Text
            GameObject textObject = new GameObject("button text");
            textObject.transform.SetParent(imageObject.gameObject.transform, false);
            //used to prevent text object from blocking clicks
            CanvasGroup cg = textObject.AddComponent<CanvasGroup>();
            cg.blocksRaycasts = false;
            Text panelText = textObject.AddComponent<Text>();
            panelText.alignment = TextAnchor.MiddleCenter;
            panelText.color = Color.black;
            panelText.font = Resources.GetBuiltinResource<Font>("Arial.ttf");
            panelText.fontSize = 30;
            panelText.fontStyle = FontStyle.Bold;
            panelText.text = "Make current Prefab Permanent";
            RectTransform ptRT = panelText.GetComponent<RectTransform>();
            ptRT.anchorMin = new Vector2(0, .02f);
            ptRT.anchorMax = Vector2.one;
            ptRT.sizeDelta = Vector2.zero;
        }
        private void TypeValueChanges(string value)
        {
            selectedType = value;
            RefreshPrefabCollection();
            List<PrefabCollection> a = prefabFiles[value];
            prefabNames = a.Select(x => x.ItemName).ToList();
            prefabNames.Insert(0, "");
            jsc2.SetVal("");
            ResetItem();
            jsc2.choices = prefabNames;
        }
        private void ItemValueChanged(string value)
        {
            selectedItem = value;
            _DM.RemoveTempDecalPanels();
            if (value == "")
            {
                ResetItem();
            }
            else
            {
                PrefabCollection c = prefabFiles[selectedType].Where(x => x.ItemName == value).FirstOrDefault();
                //reset decals added from other prefabs
                if (c.ImagePath != null)
                    ImagePanel.LoadPNG(c.ImagePath, ImagePanel);
                _DM.PresetLoad(c.Path, true, c.Package);
            }
        }
        private void ResetItem()
        {
            _DM.RemoveTempDecalPanels();
            ImagePanel.ClearTexture();
            _DM.PresetLoad(_DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Icons/EMPTY.dsgn.DecalMakerPreset.json", true);
        }
        public void RefreshPrefabCollection()
        {
            string path = FileManagerSecure.NormalizePath("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Presets/PreFabs");
            if (!FileManagerSecure.DirectoryExists(path))
                return;
            prefabFiles = new Dictionary<string, List<PrefabCollection>>();
            List<string> files = _DM.GetFilesAtPathRecursive(path, null);
            List<ShortCut> shortCuts = FileManagerSecure.GetShortCutsForDirectory(path);
            foreach (ShortCut s in shortCuts)
            {
                if (s.isLatest && s.package != "" && s.package != "AddonPackages Flattened" && s.package != "AddonPackages Filtered")
                {
                    List<string> temp = _DM.GetFilesAtPathRecursive(s.path, null);
                    foreach (string SCFile in temp)
                    {
                        PrefabCollection pc = new PrefabCollection(SCFile, s.package);
                        if (pc.ItemType != null)
                        {
                            if (prefabFiles.ContainsKey(pc.ItemType))
                            {
                                prefabFiles[pc.ItemType].Add(pc);
                            }
                            else
                            {
                                prefabFiles.Add(pc.ItemType, new List<PrefabCollection>() { pc });
                            }
                        }
                    }
                }
            }
            foreach (string file in files)
            {
                PrefabCollection pc = new PrefabCollection(file);
                if (pc.ItemType != null)
                {
                    if (prefabFiles.ContainsKey(pc.ItemType))
                    {
                        prefabFiles[pc.ItemType].Add(pc);
                    }
                    else
                    {
                        prefabFiles.Add(pc.ItemType, new List<PrefabCollection>() { pc });
                    }
                }
            }
            prefabTypes = prefabFiles.Keys.ToList();
            jsc.choices = prefabTypes;
        }
        public void OnClick()
        {
            bool state = !spacerLeft.gameObject.activeSelf;
            spacerLeft.gameObject.SetActive(state);
            spacerRight.gameObject.SetActive(state);
            RefreshPrefabCollection();
        }
    }
}
//*** SourceCombiner -> original file PreviewAnchor.cs ***
namespace VAM_Decal_Maker
{
    public class PreviewAnchor
    {
        public GameObject gameObject = new GameObject("PreviewPanel");
        private Image image;
        public PreviewAnchor(Decal_Maker DM)
        {
            Transform parent = DM.UITransform;
            gameObject.transform.SetParent(parent, false);
            gameObject.transform.localPosition = new Vector3(1650, 0, 0);
            //debug image
            //image = gameObject.AddComponent<Image>();
            //image.material = new Material(Shader.Find("UI/Default-Overlay"));
            //image.material.color = new Color(1,0,0,0.0f);
            //RectTransform imageRect = image.rectTransform;
            //imageRect.sizeDelta = new Vector2(2080, 2080);
            gameObject.SetActive(false);
        }
    }
}
//*** SourceCombiner -> original file PreviewPanel.cs ***
namespace VAM_Decal_Maker
{
    public class PreviewPanel
    {
        public GameObject gameObject = new GameObject("PreviewPanel");
        public Image image;
        private List<ImagePanel> panelList = new List<ImagePanel>();
        private RectTransform imageRect;
        private Shader shader;
        private int currentScale = 0;
        private Decal_Maker _DM;
        public PreviewPanel(Decal_Maker DM, ManagerPanel m)
        {
            image = gameObject.AddComponent<Image>();
            shader = GetShader(DM, m.isNormalMap, m.linear);
            image.material = new Material(shader);
            image.material.color = Color.white;
            imageRect = image.rectTransform;
            imageRect.sizeDelta = new Vector2(2048, 2048);
            panelList.Add(m.ImagePanel);
            Button b = gameObject.AddComponent<Button>();
            b.onClick.AddListener(() => { DM.OnCoreChange(this, new PanelEventArgs("Scale")); });
            DM.CoreEvent += EventReciver;
            _DM = DM;
        }
        private void EventReciver(object o, PanelEventArgs e)
        {
            switch (e.EventName)
            {
                case "Scale":
                    //SuperController.LogError("Change Scale Event " + this.GetHashCode() + " " + currentScale);
                    ChangeScale();
                    break;
                case "Preview Win Selected":
                    if (o == this)
                    {
                        //SuperController.LogError("Change Scale Event gameObject.SetActive(true)" + this.GetHashCode());
                        gameObject.SetActive(true);
                    }
                    else
                    {
                        //SuperController.LogError("Change Scale Event gameObject.SetActive(false)" + this.GetHashCode());
                        gameObject.SetActive(false);
                    }
                    break;
            }
        }
        private Shader GetShader(Decal_Maker DM, bool isNormalMap, bool linear)
        {
            if (isNormalMap)
            {
                return DM._customNormShader;
            }
            else if (linear) //gloss and spec
            {
                return DM._customSpecGlossShader;
            }
            else
            {
                return DM._customBulkDecalShader;
            }
        }
        private void ResetImage()
        {
            GameObject.Destroy(image.material);
            image.material = new Material(shader);
            foreach (ImagePanel i in panelList)
            {
                SetImage(i);
            }
        }
        private void SetImage(ImagePanel i, int index)
        {
            if (i.isNormalMap)
            {
                //SuperController.LogError(" image.material.SetFloat(_BumpMapScale");
                image.material.SetFloat("_BumpMapScale" + index, i.sliderValue);
                image.material.SetTexture("_BumpMap" + index, i.mainTexture);
            }
            else if (i.linear) //gloss and spec
            {
                //SuperController.LogError("image.material.SetVector(_SpecColor");
                image.material.SetVector("_SpecColor" + index, new Vector4(1, 1, 1, 0.5f));
                //image.material.SetFloat("_Smoothness" + index, i.sliderValue);
                image.material.SetTexture("_SpecTex" + index, i.mainTexture);
            }
            else
            {
                //SuperController.LogError("image.material.SetVector(_DecalColor");
                image.material.SetVector("_DecalColor" + index, i.color);
                image.material.SetTexture("_DecalTex" + index, i.mainTexture);
            }
        }
        private void SetImage(ImagePanel i)
        {
            int index = panelList.IndexOf(i);
            SetImage(i, index);
        }
        public void PanelChangeEvent(object o, PanelEventArgs e)
        {
            switch (e.EventName)
            {
                case "Create":
                    //SuperController.LogError("if (e.Operation ==" + e.Operation);
                    AddPanel(e.DecalPanel);
                    break;
                case "Delete":
                    // SuperController.LogError("if (e.Operation ==" + e.Operation);
                    RemovePanel(e.DecalPanel);
                    break;
                case "Material":
                    if (o is ManagerPanel)
                    {
                        ManagerPanel m = (ManagerPanel)o;
                        SetImage(m.ImagePanel, 0);
                    }
                    else
                    {
                        // SuperController.LogError("MAT CHANGE" + o.GetType());
                        ImagePanel imagePanel = (ImagePanel)o;
                        SetImage(imagePanel);
                    }
                    break;
                case "Color":
                    // SuperController.LogError("Color CHANGE" + o.GetType());
                    ImagePanel ip = (ImagePanel)o;
                    SetImage(ip);
                    break;
                case "Sort":
                    ImagePanel basePanel = panelList.FirstOrDefault();
                    panelList = new List<ImagePanel>();
                    panelList.Add(basePanel);
                    foreach (DecalPanel d in e.DecalPanels)
                    {
                        panelList.Add(d.ImagePanel);
                    }
                    ResetImage();
                    break;
            }
        }
        private void AddPanel(DecalPanel d)
        {
            int c = panelList.Count - 1;
            //SuperController.LogError("Added at index " + c);
            panelList.Add(d.ImagePanel);
            d.ImagePanel.ImagePanelUpdate += PanelChangeEvent;
        }
        private void RemovePanel(DecalPanel d)
        {
            int index = panelList.IndexOf(d.ImagePanel);
            //SuperController.LogError("Remove at index " + index + " of " + panelList.Count);
            panelList.Remove(d.ImagePanel);
            ResetImage();
        }
        private void ChangeScale()
        {
            switch (currentScale)
            {
                case 0:
                    gameObject.transform.localPosition = new Vector3(-760, 0, 0); //1024
                    imageRect.sizeDelta = new Vector2(512, 512);
                    currentScale = 1;
                    break;
                case 1:
                    gameObject.transform.localPosition = new Vector3(-510, 0, 0); //1024
                    imageRect.sizeDelta = new Vector2(1024, 1024);
                    currentScale = 2;
                    break;
                case 2:
                    gameObject.transform.localPosition = new Vector3(0, 0, 0); //2048
                    imageRect.sizeDelta = new Vector2(2048, 2048);
                    currentScale = 0;
                    break;
            }
        }
    }
}
//*** SourceCombiner -> original file RenderPanelSpecGloss.cs ***
namespace VAM_Decal_Maker
{
    public class RenderPanelSpecGloss : RenderPanelBase
    {
        private Texture2D _clearTex;
        public RenderPanelSpecGloss(Decal_Maker DM, string MaterialSlot, string TextureSlot) : base(DM, MaterialSlot, TextureSlot)
        {
            material = new Material(DM._customSpecGlossShader);
            _clearTex = DM.GetResource("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Clear.png", true);
            tempTexture = new Texture2D(4096, 4096, TextureFormat.RGBA32, false, true);
        }
        public override IEnumerator ApplyChanges()
        {
            int count = 0;
            bool multiRender = false;
            ZeroMaterial();
            //if we have a specular material on Base model use it as spec0
            Texture2D mainTex = GetGPUTexture(MaterialSlot, TextureSlot);
            if (mainTex != null)
            {
                material.SetVector("_SpecColor" + count, new Vector4(1, 1, 1, 0.5f));
                material.SetTexture("_SpecTex" + count, mainTex);
                count = 1;
            }
            foreach (DecalPanel d in DecalPanels)
            {
                material.SetVector("_SpecColor" + count, new Vector4(1, 1, 1, 0.5f));
                material.SetTexture("_SpecTex" + count, d.ImagePanel.mainTexture);
                //material.SetFloat("_Smoothness" +count, d.ImagePanel.sliderValue);
                count++;
                //we can bake 10 textures per material
                if (count > 9)
                {
                    count = 0;
                    yield return GpuCombine(_clearTex, material, true);
                    ZeroMaterial();
                    multiRender = true;
                }
            }
            if (multiRender)
            {
                yield return GpuCombine(tempTexture, material, true);
            }
            else
            {
                yield return GpuCombine(_clearTex, material, true);
            }
            //apply textures
            SetGPUTexture(tempTexture, MaterialSlot, TextureSlot);
            //Only un-flag IsDirty if no updates happened while processing.
            if (dirtyTimeStart == dirtyTime)
            {
                IsDirty = false;
            }
            Processing = false;
        }
        protected void ZeroMaterial()
        {
            for (int i = 0; i < 10; i++)
            {
                material.SetVector("_SpecColor" + i, new Vector4(1, 1, 1, 0));
                material.SetTexture("_SpecTex" + i, null);
            }
        }
    }
}
//*** SourceCombiner -> original file RenderPanelNormal.cs ***
namespace VAM_Decal_Maker
{
    public class RenderPanelNormal : RenderPanelBase
    {
        private Texture2D _normTex;
        public Texture2D BlankNormalTex { get { return _normTex; } }
        public RenderPanelNormal(Decal_Maker DM, string MaterialSlot, string TextureSlot) : base(DM, MaterialSlot, TextureSlot)
        {
            material = new Material(DM._customNormShader);
            byte[] tmppng = FileManagerSecure.ReadAllBytes(DM.GetPackagePath() + "Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Normal.png");
            _normTex = new Texture2D(1, 1, TextureFormat.RGBA32, false, true);
            _normTex.LoadImage(tmppng);
            tempTexture = new Texture2D(4096, 4096, TextureFormat.RGBA32, false, true);
        }
        //convert normal from packed version for UI button display
        public Texture2D ConvertNormal(Texture2D mainTex)
        {
            material.SetTexture("_BumpMap0", mainTex);
            material.SetFloat("_BumpMapScale0", 1);
            DM.DebugSave(_normTex, "REnderNorm norm.png");
            GpuCombine(_normTex, material, true);
            return tempTexture;
        }
        public override IEnumerator ApplyChanges()
        {
            int count = 0;
            ZeroMaterial();
            //if we have a specular material on Base model use it as spec0
            Texture2D mainTex = (Texture2D)DM._headerPanel.SelectionPanelNorm.Selections[TextureSlot].mainTexture;
           if (mainTex != null)
            {
                material.SetTexture("_BumpMap" + count, mainTex);
                count = 1;
            }
            bool multiRender = false;
            foreach (DecalPanel d in DecalPanels)
            {
                material.SetFloat("_BumpMapScale" + count, d.ImagePanel.sliderValue);
                material.SetTexture("_BumpMap" + count, d.ImagePanel.mainTexture);
                count++;
                //we can bake 10 textures per material
                if (count > 9)
                {
                    count = 0;
                    yield return GpuCombine(_normTex, material, true);
                    ZeroMaterial();
                    multiRender = true;
                }
            }
            if (multiRender)
            {
                yield return GpuCombine(tempTexture, material, true);
            }
            else
            {
                yield return GpuCombine(_normTex, material, true);
            }
            SetGPUTexture(tempTexture, MaterialSlot, TextureSlot);
            //Only un-flag IsDirty if no updates happened while processing.
            if (dirtyTimeStart == dirtyTime)
            {
                IsDirty = false;
            }
            Processing = false;
        }
        //recycle material by setting alphas back to 0
        protected void ZeroMaterial()
        {
            for (int i = 0; i < 10; i++)
            {
                material.SetFloat("_BumpMapScale" + i, 1);
                material.SetTexture("_BumpMap" + i, null);
            }
        }
    }
}
//*** SourceCombiner -> original file RenderPanelDecal.cs ***
namespace VAM_Decal_Maker
{
    public class RenderPanelDecal : RenderPanelBase
    {
        private Texture2D _clearTex;
        public RenderPanelDecal(Decal_Maker DM, string MaterialSlot, string TextureSlot) : base(DM, MaterialSlot, TextureSlot)
        {
            material = new Material(DM._customBulkDecalShader);
            tempTexture = new Texture2D(4096, 4096, TextureFormat.RGBA32, false, false);
            _clearTex = DM.GetResource("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/Clear.png");
        }
        public override IEnumerator ApplyChanges()
        {
            ZeroMaterial();
            //Uses shader to clip part of one texture and applys it to another based on the alpha of a third texture.
            //Used to Apply "Clean" nipples and genital areas after decals have been applied.
            //This Alpha control will be Character UV specific. So Victoria has a diffrent nipple area than Olympia etc..
            if (TextureSlot == "torso" && DM._toggleNippleCutout.val)
            {
                DM.GetBoolJSONParam("Nipple Cutouts ON");
                Texture2D alphaTex = DM.GetResource("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/" + DM._uvSetName + ".png");
                material.SetTexture("_Alpha", alphaTex);
            }
            if (TextureSlot == "genitals" && DM._toggleGenitalCutout.val && DM._isMale == false)
            {
                Texture2D alphaTex = DM.GetResource("Custom/Scripts/Chokaphi/VAM_Decal_Maker/Cutout/_FemaleGenitals.png");
                material.SetTexture("_Alpha", alphaTex);
            }
            int count = 0;
            bool linear = false;
            bool multiRender = false;
            foreach (DecalPanel d in DecalPanels)
            {
                material.SetVector("_DecalColor" + count, d.ImagePanel.color);
                material.SetTexture("_DecalTex" + count, d.ImagePanel.mainTexture);
                linear = d.ImagePanel.linear;
                count++;
                //we can bake 10 textures per material
                if (count > 9)
                {
                    count = 0;
                    yield return GpuCombine(_clearTex, material, linear);
                    ZeroMaterial();
                    multiRender = true;
                }
            }
            if (multiRender)
            {
                yield return GpuCombine(tempTexture, material, linear);
            }
            else
            {
                yield return GpuCombine(_clearTex, material, linear);
            }
            SetGPUTexture(tempTexture, MaterialSlot, TextureSlot);
            //Only un-flag IsDirty if no updates happened while processing.
            if (dirtyTimeStart == dirtyTime)
            {
                IsDirty = false;
            }
            Processing = false;
        }
        //recycle material by setting alphas back to 0
        private void ZeroMaterial()
        {
            material.SetTexture("_Alpha", null);
            for (int i = 0; i < 10; i++)
            {
                material.SetVector("_DecalColor" + i, Color.clear);
                material.SetTexture("_DecalTex" + i, null);
            }
        }
    }
}
//*** SourceCombiner -> original file RenderPanelBase.cs ***
namespace VAM_Decal_Maker
{
    public class RenderPanelBase
    {
        protected Decal_Maker DM;
        protected bool Processing = false;
        protected float dirtyTime = Time.time;
        protected float dirtyTimeStart = Time.time;
        protected Material material;
        protected List<Material> materials = new List<Material>();
        protected Dictionary<string, int[]> femaleTextureIndex = new Dictionary<string, int[]>()
        {
            {"torso", new int[]{15,18,19,20,21,27,29}},
            {"face", new int[]{2,5,11} },
            {"limbs", new int[]{0,12,14,16,17,22,23}},
            {"genitals", new int[]{28}}
        };
        protected Dictionary<string, int[]> maleTextureIndex = new Dictionary<string, int[]>()
        {
            {"torso", new int[]{15,16,19,20,21,22,30,32}},
            {"face", new int[]{2,5,11}},
            {"limbs", new int[]{0,12,14,17,18,23,24}},
            {"genitals", new int[]{28,29}}
        };
        public bool IsMale { get; set; }
        public string TextureSlot { get; protected set; }
        public string MaterialSlot { get; protected set; }
        public List<DecalPanel> DecalPanels { get; set; }
        private bool _isDirty = false;
        public bool IsDirty { get 
            { 
                return _isDirty; 
            } 
            set 
            {
                _isDirty = value;
                if (value == true)
                    dirtyTime = Time.time;     
            } 
        }
        //this is our target texture will alway update referance in all materials it is assigned to 
        protected Texture2D tempTexture { get; set; }
        protected Dictionary<string, int[]> _TextureIndex
        {
            get
            {
                if (IsMale)
                    return maleTextureIndex;
                return femaleTextureIndex;
            }
        }
        public RenderPanelBase(Decal_Maker DM, string MaterialSlot, string TextureSlot)
        {
            this.DM = DM;
            this.IsMale = DM._isMale;
            DM.OnUpDate += Update;
            this.MaterialSlot = MaterialSlot;
            this.TextureSlot = TextureSlot;
        }
        public bool GpuCombine(Texture2D baseTex, Material material, bool linear = false)
        {        
            int w = baseTex.width;
            int h = baseTex.height;
            RenderTextureReadWrite renderTexConversion = RenderTextureReadWrite.sRGB;
            if (linear)
            {
                renderTexConversion = RenderTextureReadWrite.Linear;
            }
            RenderTexture tmp = RenderTexture.GetTemporary(w, h, 0, RenderTextureFormat.ARGB32, renderTexConversion);        //tmp.antiAliasing = 8;                                                                                                                           //Backup the currently set RenderTexture
            RenderTexture previous = RenderTexture.active;
            Graphics.Blit(baseTex, tmp, material);
            RenderTexture.active = tmp;
            //tempTexture = new Texture2D(w, h, TextureFormat.RGBA32, false, linear);
            tempTexture.ReadPixels(new Rect(0, 0, w, h), 0, 0, false);
            tempTexture.Apply();
            // Reset the active RenderTexture
            RenderTexture.active = previous;
            RenderTexture.ReleaseTemporary(tmp);
            return true;
        }
        public void Update()
        {
            //SuperController.LogError("OnLateUpdate()");
            if (IsDirty)
            {
                if (!Processing)
                {
                    dirtyTimeStart = dirtyTime;
                    Processing = true;
                    DM.StartCoroutine(ApplyChanges());
                }
            }
        }
        public virtual IEnumerator ApplyChanges()
        {
            yield return null;
        }
        public void OnDestroy()
        {
            //delete materials and texture references
            foreach (Material mat in materials)
            {
                GameObject.Destroy(mat);
            }
            if (material != null)
                GameObject.Destroy(material);
            if (tempTexture != null)
                GameObject.Destroy(tempTexture);
        }
        public Texture2D GetGPUTexture(string MaterialSlot, string TextureSlot)
        {
            int num = _TextureIndex[TextureSlot].FirstOrDefault();
            return (Texture2D)DM._dazSkin.GPUmaterials[num].GetTexture(MaterialSlot);
        }
        protected void SetGPUTexture(Texture2D tempTex, string MaterialSlot, string TextureSlot)
        {
            //apply textures
            foreach (int num in _TextureIndex[TextureSlot])
            {
                DM._dazSkin.GPUmaterials[num].SetTexture(MaterialSlot, tempTex);
            }
        }
        //From https://support.unity3d.com/hc/en-us/articles/206486626-How-can-I-get-pixels-from-unreadable-textures-
        //public Texture2D GetUnreadableTexture(Texture2D texture, bool linear = false)
        //{
        //    RenderTextureReadWrite renderTexConversion = RenderTextureReadWrite.sRGB;
        //    if (linear)
        //    {
        //        renderTexConversion = RenderTextureReadWrite.Linear;
        //    }
        //    //LogError("Get Unreadable texture");
        //    RenderTexture tmp = RenderTexture.GetTemporary(texture.width, texture.height, 0, RenderTextureFormat.ARGB32, renderTexConversion);
        //    // Blit the pixels on texture to the RenderTexture
        //    Graphics.Blit(texture, tmp);
        //    // Backup the currently set RenderTexture
        //    RenderTexture previous = RenderTexture.active;
        //    // Set the current RenderTexture to the temporary one we created
        //    RenderTexture.active = tmp;
        //    Texture2D newTexture = TempManager.TempTexture2D(texture.width, texture.height, TextureFormat.RGBA32, false, linear);
        //    newTexture.ReadPixels(new Rect(0, 0, tmp.width, tmp.height), 0, 0);
        //    newTexture.Apply();
        //    // Reset the active RenderTexture
        //    RenderTexture.active = previous;
        //    // Release the temporary RenderTexture
        //    RenderTexture.ReleaseTemporary(tmp);
        //    //LogError("Finish Getting Unreadable texture");
        //    return newTexture;
        //}
    }
}
//*** SourceCombiner -> original file SelectionPanel.cs ***
namespace VAM_Decal_Maker
{
    public class SelectionPanel
    {
        public GameObject gameObject = new GameObject("Panel");
        public string PanelName { get; set; }
        public UIDynamicButton AddButton { get; private set; }
        public UIDynamicButton RemoveButton { get; private set; }
        public Dictionary<string, ManagerPanel> Selections { get; private set; }
        public ManagerPanel ActivePanel { get; private set; }
        public ManagerPanel TorsoPanel { get; private set; }
        public ManagerPanel GenitalPanel { get; private set; }
        public ManagerPanel FacelPanel { get; private set; }
        public ManagerPanel LimbsPanel { get; private set; }
        public string MaterialSlot { get; set; }
        public bool isNormalMap { get; set; } = false;
        public bool linear { get; set; } = false;
        public event EventHandler<PanelEventArgs> SelectionPanelUpdate;
        private Decal_Maker _DM;
        private BasePanel _basePanel;
        private UIDynamic spacerLeft { get { return _basePanel.spacerLeft; } }
        private UIDynamic spacerRight { get { return _basePanel.spacerRight; } }
        //events for this class
        private void OnManagerPanelChange(object o, PanelEventArgs e)
        {
            if (SelectionPanelUpdate != null)
            {
                e.SelectionPanel = this;
                SelectionPanelUpdate(this, e);
            }
        }
        //events from manager panel
        private void ManagerPanelEvent(object o, PanelEventArgs e)
        { 
            OnManagerPanelChange(this, e);
        }
        //events from Core
        private void CorePanelEvent(object o, PanelEventArgs e)
        {
        }
        public SelectionPanel(float width, float height, Color? color, Decal_Maker DM)
        {
            _basePanel = new BasePanel(DM, 300);
            //Image i = spacerLeft.gameObject.AddComponent<Image>();
            //i.material = new Material(Shader.Find("UI/Default-Overlay"));
            //i.material.color = Color.blue;
            _DM = DM;
            DM.CoreEvent += CorePanelEvent;
            //create buttons to add/remove panels
            AddButton = DM.CreateButton("Add Image");
            RemoveButton = DM.CreateButton("Remove Image", true);
            gameObject.transform.SetParent(spacerLeft.transform, false);
            gameObject.transform.localPosition += new Vector3(270, 0, 0);
            //basePanel
            Image panelImage = gameObject.AddComponent<Image>();
            panelImage.material = new Material(Shader.Find("UI/Default-Overlay"));
            panelImage.color = color ?? new Color(.9f, .9f, .9f, 1);
            panelImage.rectTransform.sizeDelta = new Vector2(width, height);
            GridLayoutGroup glg = gameObject.AddComponent<GridLayoutGroup>();
            glg.cellSize = new Vector2(250, 250);
            glg.constraint = GridLayoutGroup.Constraint.FixedRowCount;
            glg.constraintCount = 1;
            glg.padding = new RectOffset(10, 10, 10, 10);
            glg.spacing = new Vector2(10, 0);
            AddButton.button.onClick.AddListener(() => { AddDecalPanel(); });
            RemoveButton.button.onClick.AddListener(RemoveDecalPanel);
        }
        public void CreatePanels()
        {
            //Torso panel
            TorsoPanel = new ManagerPanel(_DM, null, "torso", MaterialSlot, isNormalMap, linear);
            TorsoPanel.gameObject.transform.SetParent(gameObject.transform, false);
            TorsoPanel.ManagerPanelUpdate += ManagerPanelEvent;
            //Genital panel
            GenitalPanel = new ManagerPanel(_DM, null, "genitals", MaterialSlot, isNormalMap, linear);
            GenitalPanel.gameObject.transform.SetParent(gameObject.transform, false);
            GenitalPanel.ManagerPanelUpdate += ManagerPanelEvent;
            //Face panel
            FacelPanel = new ManagerPanel(_DM, null, "face", MaterialSlot, isNormalMap, linear);
            FacelPanel.gameObject.transform.SetParent(gameObject.transform, false);
            FacelPanel.ManagerPanelUpdate += ManagerPanelEvent;
            //Limbs panel
            LimbsPanel = new ManagerPanel(_DM, null, "limbs", MaterialSlot, isNormalMap, linear);
            LimbsPanel.gameObject.transform.SetParent(gameObject.transform, false);
            LimbsPanel.ManagerPanelUpdate += ManagerPanelEvent;
            ActivePanel = TorsoPanel;
            Selections = new Dictionary<string, ManagerPanel>() { { "torso", TorsoPanel }, { "genitals", GenitalPanel }, { "face", FacelPanel }, { "limbs", LimbsPanel } };
            foreach (var sel in Selections)
            {
                sel.Value.Button.onClick.AddListener(() =>
                {
                    foreach (var b in Selections)
                    {
                        if (b.Key == sel.Key)
                        {
                            b.Value.Button.image.color = Color.white;
                            b.Value.ActivateWindow(true);
                            ActivePanel = b.Value;
                        }
                        else
                        {
                            b.Value.Button.image.color = Color.grey;
                            b.Value.ActivateWindow(false);
                        }
                    }
                });
            }
            ActivateWindow(false);
        }
        public void ActivateWindow(bool value)
        {
            spacerLeft.gameObject.SetActive(value);
            spacerRight.gameObject.SetActive(value);
            AddButton.gameObject.SetActive(value);
            RemoveButton.gameObject.SetActive(value);
            ActivePanel.ActivateWindow(value);
        }
        public JSONClass Save()
        {
            JSONClass jc = new JSONClass();
            foreach (var selPanel in Selections)
            {
                JSONArray Panel = new JSONArray();
                if (selPanel.Value.DecalPanels.Count > 0)
                {
                    foreach (DecalPanel d in selPanel.Value.DecalPanels)
                    {
                        JSONClass tempDecal = d.Save();
                        Panel.Add("", tempDecal);
                    }
                }
                jc[selPanel.Key] = Panel;
            }
            return jc;
        }
        public DecalPanel AddDecalPanel()
        {
            DecalPanel d = ActivePanel.AddDecalPanels();
            return d;
        }
        public DecalPanel AddDecalPanel(string panelName, bool temp = false)
        {
            ManagerPanel active = null;
            switch (panelName)
            {
                case "torso":
                    active = TorsoPanel;
                    break;
                case "genitals":
                    active = GenitalPanel;
                    break;
                case "face":
                    active = FacelPanel;
                    break;
                case "limbs":
                    active = LimbsPanel;
                    break;
            }
            DecalPanel d = active.AddDecalPanels(temp);
            return d;
        }
        public void RemoveDecalPanel()
        {
            ActivePanel.RemoveDecalPanel();
        }
        public void RemoveTempDecalPanels()
        {
            _DM.StartCoroutine(TorsoPanel.RemoveTempDecalPanels());
            _DM.StartCoroutine(GenitalPanel.RemoveTempDecalPanels());
            _DM.StartCoroutine(FacelPanel.RemoveTempDecalPanels());
            _DM.StartCoroutine(LimbsPanel.RemoveTempDecalPanels());
        }
    }
}
//*** SourceCombiner -> original file TempManager.cs ***
namespace VAM_Decal_Maker
{
    public static class TempManager
    {
        //truely temp
        private static List<UnityEngine.Object> tempObjects;
        //need to keep until character or skin change
        private static List<UnityEngine.Object> sessionObjects;
        public static MVRScript mVR { get; set; }
        static TempManager()
        {
            tempObjects = new List<UnityEngine.Object>();
            sessionObjects = new List<UnityEngine.Object>();
        }
        //Create Temp Material
        public static Material TempMaterial(Shader shader)
        {
            Material temp = new Material(shader);
            tempObjects.Add(temp);
            return temp;
        }
        //Create Temp Texture
        public static Texture2D TempTexture2D(int width, int height, TextureFormat format, bool mip = false, bool linear = false)
        {
            Texture2D temp = new Texture2D(width, height, format, mip, linear);
            tempObjects.Add(temp);
            //LogError("Stored temp objects contains " + tempObjects.Count);
            return temp;
        }
        //Create Copy of existing texture
        public static Texture2D CopyTexture(Texture2D src, bool linear = false)
        {
            Texture2D cpy = TempTexture2D(src.width, src.height, src.format, false, linear);
            Graphics.CopyTexture(src, cpy);
            return cpy;
        }
        //copy temp into session
        public static void MakeSessionObj(UnityEngine.Object obj)
        {
            if (obj == null)
                return;
            tempObjects.Remove(obj);
            sessionObjects.Add(obj);
        }
        //remove temp texture
        public static void DestroyTexture(UnityEngine.Object obj)
        {
            if (obj == null)
                return;
            tempObjects.Remove(obj);
            UnityEngine.Object.Destroy(obj);
        }
        public static void DestoryTempObjs()
        {
            foreach (var obj in tempObjects)
            {
                UnityEngine.Object.Destroy(obj);
            }
            tempObjects = new List<UnityEngine.Object>();
            //LogError("Stored temp objects Destoyed");
        }
        public static void DestorySessionObjects()
        {
            foreach (var obj in sessionObjects)
            {
                UnityEngine.Object.Destroy(obj);
            }
            sessionObjects = new List<UnityEngine.Object>();
            //LogError("Stored temp objects Destoyed");
        }
        public static void DestoryAll()
        {
            foreach (var obj in tempObjects)
            {
                UnityEngine.Object.Destroy(obj);
            }
            foreach (var obj in sessionObjects)
            {
                UnityEngine.Object.Destroy(obj);
            }
            tempObjects = new List<UnityEngine.Object>();
            sessionObjects = new List<UnityEngine.Object>();
            //LogError("All temp objects Destoyed");
        }
        public static string GenerateCacheSig(List<DecalPanel> DecalPanels)
        {
            //calculate what current panels cache name will be
            string nips = mVR.GetBoolJSONParam("Nipple Cutouts ON").val.ToString();
            string gens = mVR.GetBoolJSONParam("Genital Cutouts ON").val.ToString();
            string cacheSig = string.Concat(new string[] { nips, "_", gens, "_" });
            foreach (DecalPanel d in DecalPanels)
            {
                string h = d.ImagePanel.imageHash;
                string r = d.Color.r.ToString();
                string g = d.Color.g.ToString();
                string b = d.Color.b.ToString();
                string a = d.sliderDynamic.slider.value.ToString();
                cacheSig += string.Concat(new string[] { h, "_", r, "_", g, "_", b, "_", a, "-" });
            }
            return cacheSig;
        }
        private static Dictionary<string, CacheFile> CacheFiles = null;
        public static void SaveCacheMeta()
        {
            try
            {
                JSONClass cacheFileJSON = new JSONClass();
                foreach (var dic in CacheFiles)
                {
                    JSONArray temp = new JSONArray();
                    temp.Add(dic.Value.FileName);
                    temp.Add(dic.Value.Created.ToString());
                    temp.Add(dic.Value.width.ToString());
                    temp.Add(dic.Value.height.ToString());
                    temp.Add(dic.Value.format.ToString());
                    temp.Add(dic.Value.linear.ToString());
                    cacheFileJSON[dic.Key] = temp;
                }
                mVR.SaveJSON(cacheFileJSON, cachePath + "CacheFiles.json");
            }
            catch (Exception e)
            {
                SuperController.LogError("Failed to save Cache json " + e.Message);
            }
        }
        private static JSONClass LoadJSON(string path)
        {
            JSONClass json = new JSONClass();
            try
            {
                if (FileManagerSecure.FileExists(path))
                {
                    json = mVR.LoadJSON(path) as JSONClass;
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("DecalMaker:TempManager LoadJSON " + e.Message);
            }
            return json;
        }
        //use plugin writable directory instead of VAM Cache location
        private static string cachePath = "Custom/PluginData/Chokaphi/VAM_Decal_Maker/DecalMakerCache/";
        private static void LoadCacheMeta()
        {
            try
            {
                if (!FileManagerSecure.FileExists(cachePath))
                    FileManagerSecure.CreateDirectory(cachePath);
                JSONClass cacheFileJSON = LoadJSON(cachePath + "CacheFiles.json");
                CacheFiles = new Dictionary<string, CacheFile>();
                foreach (string a in cacheFileJSON.Keys)
                {
                    JSONArray jSONArray = cacheFileJSON[a].AsArray;
                    CacheFiles[a] = new CacheFile(jSONArray);
                }
                CleanCacheFolder();
            }
            catch (Exception e)
            {
                SuperController.LogError("Failed to load Cache json " + e.Message);
            }
        }
        public static Texture2D GetTexture(string cacheSig)
        {
            try
            {
                if (CacheFiles == null)
                    LoadCacheMeta();
                CacheFile file;
                if (CacheFiles.TryGetValue(cacheSig, out file))
                {
                    if (FileManagerSecure.FileExists(cachePath + file.FileName))
                    {
                        byte[] bytes = FileManagerSecure.ReadAllBytes(cachePath + file.FileName);
                        Texture2D tex = TempManager.TempTexture2D(file.width, file.height, file.format, false, file.linear);
                        tex.LoadRawTextureData(bytes);
                        tex.Apply(false);
                        file.UpdateTime();
                        return tex;
                    }
                    else
                    {   //cache miss from mising file
                        CacheFiles.Remove(cacheSig);
                    }
                }
                return null;
            }
            catch (Exception e)
            {
                SuperController.LogError(e.Message);
                return null;
            }
        }
        public static void SaveToCache(Texture2D texture, string cacheSig, bool linear = false)
        {
            if (CacheFiles == null)
                LoadCacheMeta();
            if (CacheFiles.ContainsKey(cacheSig))
            {
                return;
            }
            CacheFile cacheFile = new CacheFile(texture, linear);
            CacheFiles.Add(cacheSig, cacheFile);
            FileManagerSecure.WriteAllBytes(cachePath + cacheFile.FileName, texture.GetRawTextureData());
            SaveCacheMeta();
        }
        public static void CleanCacheFolder()
        {
            //remove OLD Cache entries after we get to a certain size
            if (CacheFiles.Count > 80)
            {
                int pct = (CacheFiles.Count / 100) * 20;
                var oldest = CacheFiles.OrderBy(x => x.Value.Created).Take(pct);
                Dictionary<string, CacheFile> a = oldest.ToDictionary(c => c.Key, c => c.Value);
                foreach (var old in a)
                {
                    if (RemoveFile(old.Value.FileName))
                    {
                        CacheFiles.Remove(old.Key);
                    }
                }
                SaveCacheMeta();
            }
        }
        private static bool RemoveFile(string path)
        {
            try
            {
                FileManagerSecure.DeleteFile(cachePath + path);
                return true;
            }
            catch (Exception e)
            {
                SuperController.LogError("Decal Maker Cache Remove:" + e.Message);
            }
            return false;
        }
    }
}
